<?
/* 
 * EDOMI beta (Version 1.59) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
Lädt eine beliebige Datei hoch und speichert diese in projectdata/

URL-Parameter:

	multiple: 0=einzelne Datei

		filename: Dateiname ohne Pfad (nach dem Hochladen wird die Datei unter .../www/data/tmp/<filename>.<suffix> gespeichert)
			- wird ein Suffix mit angegeben (z.B. "testdatei.txt"), wird die Datei nach dem Hochladen dieses Suffix besitzen - egal was für ein Suffix die Originaldatei hatte
			- wird kein Suffix angegeben (z.B. "testdatei"), wird die Datei nach dem Hochladen das Suffix der Originaldatei haben
			- wird filename nicht angegeben, wird der Originaldateiname übernommen (einschl. Suffix)
		suffixes: erlaubte Endungen in der Form "tar;txt;jpg;...;"
	
		ajaxok: Ajax-CMD bei Erfolg (z.B. uploadOk)
			- $phpdataArr[0] enthält dann den endgültigen Dateinamen der hochgeladenen Datei (ohne Pfad - Pfad ist immer .../www/data/tmp/)
			- $phpdataArr[1] enthält dann den original-Dateinamen der hochgeladenen Datei (ohne Pfad)
			- !!! die ajaxok-Routine muss dann die Datei ans Ziel verschieben(!) - bzw. nach Gebrauch aus dem /tmp-Verzeichnis löschen !!!
	
		ajaxerr: Ajax-CMD bei Fehler
	
		ajaxappid: AppId
		ajaxwinid: WinId (wird auch für's Shaken im Fehlerfall benötigt!)
	
		ajaxdata: Ajax-Daten ($data) - werden nicht benötigt, sondern nur durchgereicht
		sid: SID

		Beispiel der Upload-Form: (der iFrame ist wichtig - dient als Dummy-Zielseite, da sonst im Fehlerfall die aktuelle Browserseite flöten geht)
		<iframe id='<?echo $winId;?>-iframe' name='<?echo $winId;?>-iframe' style='width:1px; height:1px; display:none;'></iframe>
		<form id='<?echo $winId;?>-formupload' action='apps/app_upload.php?filename=test.txt&suffixes=jpg;gif;&ajaxok=UploadOk&ajaxerr=UploadError&ajaxappid=<?echo $appId;?>&ajaxwinid=<?echo $winId;?>&ajaxdata=<?echo $data;?>&sid=<?echo $sid;?>' target='<?echo $winId;?>-iframe' method='post' enctype='multipart/form-data'>
			<div class='cmdUpload' style='width:100%; margin-top:5px;'>Hochladen<input type='file' name='file' id='file' accept='image/*|...###...' onChange='openBusyWindow(); document.getElementById(\"<?echo $winId;?>-formupload\").submit();'></div>";
		</form>

	multiple: 1=mehrere Dateien
	
		folderid: FolderID des "Zielordners" (der Dateiname wird wie folgt generiert: .../www/data/tmp/folderid-counter_originalname.originalsuffix)
		suffixes: erlaubte Endungen in der Form "tar;txt;jpg;...;"
	
		ajaxok: Ajax-CMD nach dem Upload (auch bei Fehler!)
			- $phpdataArr[0] enthält dann die endgültigen Dateinamen und den Fehlerstatus der hochgeladenen Dateien getrennt durch ";" bzw. "|" (ohne Pfad - Pfad ist immer .../www/data/tmp/)
			- !!! die ajaxok-Routine muss dann die Dateien ans Ziel verschieben(!) - bzw. nach Gebrauch aus dem /tmp-Verzeichnis löschen !!!
		
		ajaxappid: AppId
		ajaxwinid: WinId (wird auch für's Shaken im Fehlerfall benötigt!)
	
		ajaxdata: Ajax-Daten ($data) - werden nicht benötigt, sondern nur durchgereicht
		sid: SID

		Beispiel der Upload-Form: (der iFrame ist wichtig - dient als Dummy-Zielseite, da sonst im Fehlerfall die aktuelle Browserseite flöten geht)
		<iframe id='<?echo $winId;?>-iframe' name='<?echo $winId;?>-iframe' style='width:1px; height:1px; display:none;'></iframe>
		<form id='<?echo $winId;?>-formupload' action='apps/app_upload.php?multiple=1&folderid=<?echo $fd[2];?>&suffixes=jpg;jpeg;gif;png;svg;&ajaxok=visuImgMultiuploadOk&ajaxerr=visuImgMultiuploadError&ajaxappid=<?echo $appId;?>&ajaxwinid=<?echo $winId;?>&sid=<?echo $sid;?>' target='<?echo $winId;?>-iframe' method='post' enctype='multipart/form-data'>
			<div class='cmdUpload' style='width:100%; margin-top:5px;'>Bilddateien hochladen<input type='file' name='files[]' id='files' multiple='' accept='image/*' onChange='openBusyWindow(); document.getElementById(\"<?echo $winId;?>-formupload\").submit();'></div>
		</form>
*/


//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/admin/include/php/config.php");
require(MAIN_PATH."/www/admin/include/php/base.php");


$maxFileSize=100000000;	//max. erlaubte Dateigröße (pro Datei) in Byte (muss ggf. auch in Apache/php.ini angepaßt werden!)
						//bei Multi-Upload ist dies die Gesamtgröße aller Dateien in summa (wird jedoch nicht geprüft!)

sql_connect();

?>
<script type="text/javascript">
<?

if (checkAdmin($sid,false)) {

	if (httpGetVar('multiple')==1) {
	
		//--------------------------------------------------------------------------------------------------------------------------------
		//Mehrere Dateien
		//--------------------------------------------------------------------------------------------------------------------------------
		$folderid=httpGetVar('folderid');
		$suffixes=httpGetVar('suffixes');
		$ajaxOk=httpGetVar('ajaxok');
		$ajaxErr=httpGetVar('ajaxerr');
		$ajaxAppId=httpGetVar('ajaxappid');
		$ajaxWinId=httpGetVar('ajaxwinid');
		$ajaxData=httpGetVar('ajaxdata');
				
		$allowedSuffixes=explode(';',strtolower($suffixes));				//die erlaubten Dateiendungen
		$filenames='';														//Liste mit den endgültigen Dateinamen und Status-Meldung separiert mit ";" bzw. "|" ("<status>;folderid-counter_originalname.originalsuffix|...")

		$sumSize=0;
		for ($t=0;$t<count($_FILES['files']['name']);$t++) {$sumSize+=$_FILES["files"]["size"][$t];}
		if ($sumSize<$maxFileSize) {

			for ($t=0;$t<count($_FILES['files']['name']);$t++) {
				$uploadSuffix=pathinfo($_FILES["files"]["name"][$t],PATHINFO_EXTENSION);	//Dateiendung der Originaldatei
				$filename=$folderid.'-'.$t.'_'.$_FILES["files"]["name"][$t];
				if ($_FILES["files"]["size"][$t]<$maxFileSize && in_array(strtolower($uploadSuffix),$allowedSuffixes)) {
					if ($_FILES["files"]["error"][$t]==0) {
						if (move_uploaded_file($_FILES["files"]["tmp_name"][$t],MAIN_PATH.'/www/data/tmp/'.$filename)) {
							//Ok
							$filenames.=';'.$filename.'|';
						} else {
							$filenames.='Fehler beim Hochladen der Datei;'.$filename.'|';
						}
					} else {
						$filenames.='Fehler beim Hochladen der Datei;'.$filename.'|';
					}
				} else {
					$filenames.='Falsches Format oder Bilddatei zu groß;'.$filename.'|';
				}
			}
	
			if ($ajaxOk) {
?>
				parent.ajax("<?echo $ajaxOk;?>","<?echo $ajaxAppId;?>","<?echo $ajaxWinId;?>","<?echo $ajaxData;?>","<?echo $filenames;?>");
<?
			}

		} else {
?>
			parent.jsConfirm("Die Gesamtgröße der ausgewählten Dateien übersteigt das Limit von <?echo ($maxFileSize/1000000);?> MB.","","none");
<?
		}
?>
		parent.hideBusyWindow();
<?

		
	} else {
	
		//--------------------------------------------------------------------------------------------------------------------------------
		//Einzelne Datei
		//--------------------------------------------------------------------------------------------------------------------------------
		$filename=httpGetVar('filename');
		$suffixes=httpGetVar('suffixes');
		$ajaxOk=httpGetVar('ajaxok');
		$ajaxErr=httpGetVar('ajaxerr');
		$ajaxAppId=httpGetVar('ajaxappid');
		$ajaxWinId=httpGetVar('ajaxwinid');
		$ajaxData=httpGetVar('ajaxdata');
				
		$desiredSuffix=pathinfo($filename,PATHINFO_EXTENSION); 				//gewünschte Dateiendung (oder "")
		$allowedSuffixes=explode(';',strtolower($suffixes));				//die erlaubten Dateiendungen
		$uploadSuffix=pathinfo($_FILES["file"]["name"],PATHINFO_EXTENSION);	//Dateiendung der Originaldatei
		
		$uploadOk=false;
		
		if (count($_FILES["file"])>0 && $_FILES["file"]["size"]<$maxFileSize && in_array(strtolower($uploadSuffix),$allowedSuffixes)) {
			if ($_FILES["file"]["error"]==0) {
				if (isEmpty($filename)) {
					$filename=basename($_FILES["file"]["name"]);
				} else {
					if (isEmpty($desiredSuffix)) {$filename.='.'.$uploadSuffix;}
				}
				if (move_uploaded_file($_FILES["file"]["tmp_name"],MAIN_PATH.'/www/data/tmp/'.$filename)) {
					$uploadOk=true;
					if ($ajaxOk) {
?>
						parent.ajax("<?echo $ajaxOk;?>","<?echo $ajaxAppId;?>","<?echo $ajaxWinId;?>","<?echo $ajaxData;?>","<?echo $filename;?><?echo AJAX_SEPARATOR1;?><?echo basename($_FILES["file"]["name"]);?>");
<?
					}
				}
			}
		}
		
		if (!$uploadOk) {
			//Fehler
			if ($ajaxWinId) {
?>
				parent.shakeObj("<?echo $ajaxWinId;?>");
<?
			}
			if ($ajaxErr) {
?>
				parent.ajax("<?echo $ajaxErr;?>","<?echo $ajaxAppId;?>","<?echo $ajaxWinId;?>","<?echo $ajaxData;?>","");
<?
			}
		}
		
?>
		parent.hideBusyWindow();
<?
	}
	

} else {
?>
	parent.jsLogout();
<?
}

?>
</script>
<?

sql_disconnect();

?>
