<?
/* 
 * EDOMI beta (Version 1.59) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
======================================================================================================================================================
ADMIN: Grundfunktionen
======================================================================================================================================================
*/

/*
------------------------------------------------------------------------------------------------------------------------------------------------------
Login- und SID-Handling
------------------------------------------------------------------------------------------------------------------------------------------------------
*/

function loginAdmin($login,$pass) {
	//Admin mit $login und $pass einloggen (erstellt ggf. eine neue SID)
	//return:  Array (0=SID, 1=typ, 2=id), false=ungültiges Login
	if ($n=checkAdminLoginPass($login,$pass)) {
		//SID generieren und in DB speichern
		$sid=createAdminSid();
		sql_call("UPDATE edomiAdmin.user SET sid='".$sid."',logindate=".sql_getNow().",loginip='".$_SERVER['REMOTE_ADDR']."' WHERE (id=".$n['id'].")");
		return array($sid,$n['typ'],$n['id']);
	}
	return false;
}

function logoutAdmin($sid) {
	//Logout des Admins: Löscht die SID in der db.user (darf nur ein eingeloggter Admin mit gültiger SID)
	//return: true=erfolgreich, false=echter Logout nicht möglich (ungültige SID), d.h. Session wird beendet, aber SID bleibt in db.user bestehen
	if (checkAdminSid($sid)) {
		sql_call("UPDATE edomiAdmin.user SET sid=NULL,logoutdate=".sql_getNow().",actiondate=NULL WHERE (sid='".$sid."')");
?>
		jsLogout();
<?
		return true;
	} else {
?>
		jsLogout();
<?
		return false;
	}
}

function checkAdminLoginPass($login,$pass) {
	//prüft, ob Admin-Logindaten korrekt sind 
	//return: Userdaten(Array)=Ok, false=Logindaten sind fehlerhaft
	$ss1=sql_call("SELECT * FROM edomiAdmin.user WHERE (typ<10 AND login='".sql_encodeValue($login)."' AND pass='".sql_encodeValue($pass)."')");
	if ($n=sql_result($ss1)) {
		return $n;
	}
	return false;
}

function checkAdmin($sid,$logout=true) {
	//prüft, ob Admin-Account korrekt eingeloggt ist und führt ggf. ansonsten einen Logout durch
	//$logout (OPTIONAL): false=kein Logout
	//return: true=Admin ist eingeloggt, false=Admin wird ausgeloggt
	if (checkAdminSid($sid)) {
		return true;
	} else {
		if ($logout) {logoutAdmin($sid);}
		return false;
	}
}

function checkAdminSid($sid,$mode=false) {
	//prüft, ob die SID $sid einen gültigen Admin-Account repräsentiert (quasi Loggedin-Check)
	//$mode (OPTIONAL): true=Array mit Accountdaten zurückgeben, false/leer=UserID zurückgeben
	//return: UserID/Array=SID ist gültig, false=SID ist ungültig
	if (!isEmpty($sid)) {
		$ss1=sql_call("SELECT * FROM edomiAdmin.user WHERE ((sid IS NOT NULL) AND sid='".$sid."')");
		if ($n=sql_result($ss1)) {
			sql_call("UPDATE edomiAdmin.user SET actiondate=".sql_getNow()." WHERE (id=".$n['id'].")");
			if ($mode) {
				return $n;
			} else {
				return $n['id'];
			}
		}
	}
	return false;
}

function createAdminSid() {
	//Erzeugt eine zufällige SID, die noch nicht in der db.user für den Admin-Account vorhanden ist
	//return: SID als String aus Ziffern und Buchstaben A..F (max. 30-stellig, 1. Zeichen ist immer die UserID!)
	do {
		$sid=substr(strtoupper(dechex(intval(rand(1000000,1000000000))).dechex(intval(strtotime('NOW')*rand(1,1000000))).dechex(intval(rand(1000000,1000000000)))),0,30);
		$ss1=sql_call("SELECT id FROM edomiAdmin.user WHERE (sid='".$sid."')");
	} while (sql_result($ss1));
	return $sid;
}



/*
------------------------------------------------------------------------------------------------------------------------------------------------------
Projektverwaltung
------------------------------------------------------------------------------------------------------------------------------------------------------
*/

function checkLiveProjectData() {
	//überprüft, ob das aktuelles Live-Projekt mit dem Arbeitsprojekt referenziert ist und ob EDOMI betriebsbereit ist (also ob Live-Daten verfügbar sind)
	//return: true=Live-Daten sind verfügbar, false=keine Live-Daten verfügbar
	$ss1=sql_call("SELECT id FROM edomiAdmin.project WHERE (edit=1 AND live=1)");
	if ($n=sql_result($ss1)) {
		if (getEdomiStatus()>=2) {
			return true;
		}
	}
	return false;
}

function getEditProjektId() {
	//überprüft, ob ein aktuelles Projekt vorhanden und ausgewählt ist
	//return: 1..oo=Projekt vorhanden (ID), false=kein Projekt vorhanden
	$ss1=sql_call("SELECT id FROM edomiAdmin.project WHERE (edit=1)");
	if ($n=sql_result($ss1)) {
		return $n['id'];
	}
	return false;
}

function getLiveProjektData() {
	//liefert die Daten des aktuellen Live-Projekts
	//return: ARRAY[id,name,livedate] oder false=kein Live-Projekt vorhanden
	$n=sql_getValues('edomiAdmin.project','*','live=1');
	if ($n!==false) {
		return $n;
	} else {
		//DB-Eintrag existiert nicht mehr -> aus Datei holen
		$tmp=readInfoFile(MAIN_PATH.'/www/data/liveproject/liveprojectname.txt');
		if ($tmp!==false) {
			$n['id']=$tmp[0];
			$n['name']=$tmp[1];
			$n['livedate']=$tmp[2];
			return $n;
		}
	}
	return false;
}

function getLiveProjektId() {
	//überprüft, ob ein aktuelles Live-Projekt vorhanden ist
	//return: 1..oo=Live-Projekt vorhanden (ID), false=kein Live-Projekt vorhanden
	$ss1=sql_call("SELECT id FROM edomiAdmin.project WHERE (live=1)");
	if ($n=sql_result($ss1)) {
		return $n['id'];
	} else {
		//DB-Eintrag existiert nicht mehr -> aus Datei holen
		$n=readInfoFile(MAIN_PATH.'/www/data/liveproject/liveprojectname.txt');
		if ($n!==false) {
			return $n[0];
		}
	}
	return false;
}

function getLiveProjectName() {
	//liefert den aktuellen Live-Projektnamen zurück
	//return: Live-Projektname, oder "kein Live-Projekt"
	$ss1=sql_call("SELECT * FROM edomiAdmin.project WHERE (live=1)");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class="id" style="color:#343434;">'.$n['id'].'</span>';
	} else {
		//DB-Eintrag existiert nicht mehr -> aus Datei holen
		$n=readInfoFile(MAIN_PATH.'/www/data/liveproject/liveprojectname.txt');
		if ($n!==false) {
			return ajaxEncode($n[1]).' <span class="id" style="color:#343434;">'.$n[0].'</span>';
		}
	}
	return '<span style="color:#ff0000;">kein Live-Projekt vorhanden</span>';
}

function showEditProjectName() {
	//zeigt den aktuellen Projektnamen auf dem Desktop an
	//return: Projektname, oder "kein Projekt vorhanden"
	$ss1=sql_call("SELECT * FROM edomiAdmin.project WHERE (edit=1)");
	if ($n=sql_result($ss1)) {
		if ($n['live']==1) {
			$r=ajaxEncode($n['name']).' <span class="id">'.$n['id'].'</span> <span style="color:#ffffff; border-radius:3px; background:#20e000;">&nbsp;LIVE&nbsp;</span>';
		} else {
			$r=ajaxEncode($n['name']).' <span class="id">'.$n['id'].'</span>';
		}
	} else {
		$r='<span style="color:#ff0000;">kein Projekt vorhanden</span>';
	}
?>
	document.getElementById("desktopProject").innerHTML='<?echo $r;?>';
<?
}


/*
------------------------------------------------------------------------------------------------------------------------------------------------------
Logikbausteine einlesen/parsen
------------------------------------------------------------------------------------------------------------------------------------------------------
*/

function lbs_import($id,$lbsUserFolderId=null) {
	//return: Array von lbs_parse(), oder false = Datei existiert nicht oder keine gültige LBS-Datei

	//19er LBS: ggf. User-Folder merken
	if (isEmpty($lbsUserFolderId)) {$lbsUserFolderId=sql_getValue('edomiProject.editLogicElementDef','folderid','id='.$id.' AND folderid>=1000');}

	lbs_deleteAllData($id);

	if (file_exists(MAIN_PATH.'/www/admin/lbs/'.$id.'_lbs.php')) { 
		$lbsID=substr($id,0,8);
		$lbsFolderID=substr($id,0,2);
		
		//19er LBS: ggf. FolderId auf gemerkten User-Folder setzen (s.o.)
		if (!isEmpty($lbsUserFolderId) && $lbsUserFolderId>=1000 && $lbsFolderID==19) {$lbsFolderID=$lbsUserFolderId;}		
		
		if ($r=lbs_parse($lbsID)) {
		
			//bereits vorhandene LBS-Instanzen für diesen Baustein aktualisieren
			$ss1=sql_call("SELECT * FROM edomiProject.editLogicElement WHERE (functionid=".$lbsID.")");
			while ($n=sql_result($ss1)) {
			
				//--------------------------------------
				//neue Eingänge zu DB.editLogicLink hinzufügen (einschl. Init-Wert), bzw. gelöschte Eingänge entfernen
				//--------------------------------------
				//alle vorhandenen Eingänge dieser Instanz in Array konvertieren
				$t=0;
				$curIn=array();
				$ss2=sql_call("SELECT DISTINCT(eingang) FROM edomiProject.editLogicLink WHERE (elementid=".$n['id'].") ORDER BY eingang ASC");
				while ($nn=sql_result($ss2)) {
					$curIn[$t]=$nn['eingang'];
					$t++;
				}
				sql_close($ss2);

				//Wurde ein neuer Eingang hinzugefügt?
				foreach ($r[4] as $newIn) {
					if (!in_array($newIn[0],$curIn)) {
						//Eingang existiert noch nicht => hinzufügen
						sql_save('edomiProject.editLogicLink',null,array(
							'elementid'	=>	$n['id'],
							'linktyp'	=>	2,
							'eingang'	=>	$newIn[0],
							'value'		=>	sql_encodeValue($newIn[2],true)
						));
					}
				}
								
				//Wurde ein vorhandener Eingang entfernt?
				for ($t=0; $t<count($curIn); $t++) {
					$exist=false;
					foreach ($r[4] as $newIn) {
						if ($curIn[$t]==$newIn[0]) {
							$exist=true;
							break;
						}
					}
					if (!$exist) {
						//Eingang wurde entfernt => löschen
						sql_call("DELETE FROM edomiProject.editLogicLink WHERE (elementid=".$n['id']." AND eingang=".$curIn[$t].")");
					}			
				}

				//--------------------------------------
				//gelöschte Ausgänge entfernen (neue Ausgänge sind egal)
				//--------------------------------------
				//alle vorhandenen und genutzten Ausgänge dieser Instanz in Array konvertieren
				$t=0;
				$curOut=array();
				$ss2=sql_call("SELECT ausgang FROM edomiProject.editLogicLink WHERE (linkid=".$n['id']." AND linktyp=1) GROUP BY ausgang ORDER BY ausgang ASC");
				while ($nn=sql_result($ss2)) {
					$curOut[$t]=$nn['ausgang'];
					$t++;
				}
				sql_close($ss2);


				//Wurde ein vorhandener Ausgang entfernt?
				for ($t=0; $t<count($curOut); $t++) {
					$exist=false;
					foreach ($r[5] as $newOut) {
						if ($curOut[$t]==$newOut[0]) {
							$exist=true;
							break;
						}
					}
					if (!$exist) {
						//Ausgang wurde entfernt => Verbindung auf "Initwert" setzen
						sql_call("UPDATE edomiProject.editLogicLink SET linktyp=2,linkid=null,ausgang=null WHERE (linkid=".$n['id']." AND ausgang=".$curOut[$t].")");
					}			
				}

				//--------------------------------------
				//Variablen hinzufügen oder entfernen
				//--------------------------------------
				//alle Variablen dieser Instanz löschen
				sql_call("DELETE FROM edomiProject.editLogicElementVar WHERE (elementid=".$n['id'].")");
				//alle Variablen zu dieser Instanz neu hinzufügen
				foreach ($r[6] as $newVar) {
					sql_save('edomiProject.editLogicElementVar',null,array(
						'elementid'	=>	$n['id'],
						'varid'		=>	$newVar[0],
						'value'		=>	sql_encodeValue($newVar[1],true)
					));
				}

			}
			sql_close($ss1);

			//--------------------------------------
			//Speichern
			//--------------------------------------
			sql_save('edomiProject.editLogicElementDef',null,array(
				'id'		=>	$lbsID,
				'folderid'	=>	$lbsFolderID,
				'name'		=>	sql_encodeValue($r[3],true),
				'title'		=>	sql_encodeValue($r[10],true),
				'defin'		=>	count($r[4]),
				'defout'	=>	count($r[5]),
				'defvar'	=>	count($r[6]),
				'errcount'	=>	$r[0],
				'errmsg'	=>	sql_encodeValue($r[1],true),
				'exec'		=>	(($r[2])?1:0)
			));

			foreach ($r[4] as $newIn) {
				sql_save('edomiProject.editLogicElementDefIn',null,array(
					'targetid'	=>	$lbsID,
					'id'		=>	$newIn[0],
					'name'		=>	sql_encodeValue($newIn[1],true),
					'value'		=>	sql_encodeValue($newIn[2],true),
					'color'		=>	$newIn[3]
				));
			}

			foreach ($r[5] as $newOut) {
				sql_save('edomiProject.editLogicElementDefOut',null,array(
					'targetid'	=>	$lbsID,
					'id'		=>	$newOut[0],
					'name'		=>	sql_encodeValue($newOut[1],true)
				));
			}

			foreach ($r[6] as $newVar) {
				sql_save('edomiProject.editLogicElementDefVar',null,array(
					'targetid'	=>	$lbsID,
					'id'		=>	$newVar[0],
					'value'		=>	sql_encodeValue($newVar[1],true)
				));
			}
			
			//Hilfe-Datei erstellen (wenn kein Fehler)
			if ($r[0]==0) {				
				$r[9]="<lbs-titel>".$r[3]." <span class='id'>".$lbsID."</span></lbs-titel>\n<div style='float:right; margin:0px 3px 10px 10px;'>".lbs_preview($lbsID)."</div>".$r[9];
				$f=fopen(MAIN_PATH.'/www/admin/help/lbs_'.$lbsID.'.htm','w');
				fwrite($f,$r[9]);
				fclose($f);					
			}

			return $r;
		}
	}
	return false;
}

function lbs_importAll($echo=false) {
	$tmp=glob(MAIN_PATH.'/www/admin/lbs/????????_lbs.php');
	foreach ($tmp as $pathFn) {
		if (is_file($pathFn)) {
			$id=substr(basename($pathFn),0,8);
			if ($echo) {echo $id."\n";}
			$r=lbs_import($id);
		}
	}
	lbs_optimizeTables();
}

function lbs_deleteAllData($id) {
	//löscht alle Daten des LBS, nicht jedoch die LBS-Datei selbst
	sql_call("DELETE FROM edomiProject.editLogicElementDef WHERE (id=".$id.")");
	sql_call("DELETE FROM edomiProject.editLogicElementDefIn WHERE (targetid=".$id.")");
	sql_call("DELETE FROM edomiProject.editLogicElementDefOut WHERE (targetid=".$id.")");
	sql_call("DELETE FROM edomiProject.editLogicElementDefVar WHERE (targetid=".$id.")");
	deleteFiles(MAIN_PATH.'/www/admin/help/lbs_'.$id.'.htm');
}

function lbs_optimizeTables() {
	//fehlende LBS-Dateien aus DBs entfernen
	$ss1=sql_call("SELECT id FROM edomiProject.editLogicElementDef");
	while ($n=sql_result($ss1)) {
		if (!file_exists(MAIN_PATH.'/www/admin/lbs/'.$n['id'].'_lbs.php')) {
			lbs_deleteAllData($n['id']);
		}
	}
	sql_close($ss1);
	
	//DBs optimieren
	sql_call("OPTIMIZE TABLE edomiProject.editLogicElementDef");
	sql_call("OPTIMIZE TABLE edomiProject.editLogicElementDefIn");
	sql_call("OPTIMIZE TABLE edomiProject.editLogicElementDefOut");
	sql_call("OPTIMIZE TABLE edomiProject.editLogicElementDefVar");
	sql_call("OPTIMIZE TABLE edomiProject.editLogicElement");
	sql_call("OPTIMIZE TABLE edomiProject.editLogicElementVar");
	sql_call("OPTIMIZE TABLE edomiProject.editLogicLink");
}

function lbs_checkSyntax($pathFn) {
	//prüft, ob in dem PHP-Script $pathFn ein Syntaxfehler vorhanden ist
	//$pathFn: Dateiname mit kompletten Pfad zum PHP-Script
	//return: false=keine Fehler gefunden, STRING=Fehler gefunden (PHP-Fehlermeldung)
	clearstatcache();
	exec('php -d display_errors=1 -l -n '.$pathFn,$n);	//### .' 2>&1'
	$tmp=implode($n);
	if (strpos(strtoupper($tmp),'NO SYNTAX ERRORS')!==false) {
		return false;
	} else {
		foreach ($n as $tmp) {
			$tmp=trim($tmp);
			if (!isEmpty($tmp) && strpos(strtoupper($tmp),'ERRORS PARSING')===false) {
				return $tmp;
			}
		}
		return 'unbekannter Syntaxfehler';
	}
}

function lbs_parse($lbsID,$tmpFile=false) {
	//prüft einen Logikbaustein und liefert die entsprechenden Daten zurück
	//$lbsID: ID des Logikbausteins, z.B. "13000001"
	//return: false=Logikbaustein nicht vorhanden oder ID fehlerhaft
	//		  oder ARRAY[0..9]:
	//		  	[0]: Anzahl der Fehler einschl. Syntaxfehler (0..oo), 0=keine Fehler
	//		  	[1]: Fehlermeldungen im Klartext
	//		  	[2]: true=EXEC-Aufruf vorhanden, false=kein EXEC-Aufruf vorhanden
	//		  	[3]: LBS-Name
	//		  	[4]: LBS-Eingänge als Array
	//		  	[5]: LBS-Ausgänge als Array
	//		  	[6]: LBS-Variablen als Array
	//		  	[7]: LBS-Funktion(en), fertig geparst mit ersetzter LBSID
	//		  	[8]: EXEC-Script, null/leer=EXEC leer oder kein EXEC-Aufruf vorhanden
	//		  	[9]: Hilfe-Text (mit formatiertem Titel)
	//		  	[10]: Titel (optional) im Logikeditor
	if ($tmpFile) {
		$lbsFilename=MAIN_PATH.'/www/data/tmp/tmp_lbs.php';
	} else {
		$lbsFilename=MAIN_PATH.'/www/admin/lbs/'.$lbsID.'_lbs.php';
	}
	$lbsFolderID=substr($lbsID,0,2);
	if (is_numeric($lbsID) && strlen($lbsID)==8 && file_exists($lbsFilename) && $lbsFolderID>=12 && $lbsFolderID<=19) {
		$lbsRAW=file_get_contents($lbsFilename);	//Rohdaten

		//ggf. in UTF-8 konvertieren
		if (getFileEncoding($lbsFilename)!='utf-8') {
			$lbsRAW=utf8_encode($lbsRAW);
			file_put_contents($lbsFilename,$lbsRAW);
		}

		$lbsDEF='';
		$lbsDEFname='';
		$lbsDEFtitle='';
		$lbsDEFin=Array();
		$lbsDEFout=Array();
		$lbsDEFvar=Array();
		$lbsHELP='';
		$lbsLBS='';
		$lbsEXEC='';
		$lbsEXECcall=false;
			
		$err=0;
		$errInfo='';

		//LBS-Definition
		$tmp=string_cutout($lbsRAW,'###[DEF]###','###[/DEF]###');
		if ($tmp!==false) {$lbsDEF=trim($tmp);} else {
			$err++;
			$errInfo.='kein Abschnitt ###[DEF]### vorhanden'."\n";
		}

		//LBS-Hilfe
		$tmp=string_cutout($lbsRAW,'###[HELP]###','###[/HELP]###');
		if ($tmp!==false) {$lbsHELP=trim($tmp);} else {
			$err++;
			$errInfo.='kein Abschnitt ###[HELP]### vorhanden'."\n";
		}

		//LBS-Funktion(en) 
		$tmp=string_cutout($lbsRAW,'###[LBS]###','###[/LBS]###');
		if ($tmp!==false) {$lbsLBS=trim($tmp);} else {
			$err++;
			$errInfo.='kein Abschnitt ###[LBS]### vorhanden'."\n";
		}

		//LBS-EXEC-Script 
		$tmp=string_cutout($lbsRAW,'###[EXEC]###','###[/EXEC]###');
		if ($tmp!==false) {$lbsEXEC=trim($tmp);} else {
			$err++;
			$errInfo.='kein Abschnitt ###[EXEC]### vorhanden'."\n";
		}

		//LBS-Definition parsen
		if (!isEmpty($lbsDEF)) {
			if (preg_match_all("'\[(.*?)\]'s",$lbsDEF,$tmp)>0) {
				for ($t=0;$t<count($tmp[0]);$t++) {
					$def=explode('=',$tmp[1][$t],2);
					if (count($def)==2) {
						$vName=strtoupper(trim($def[0]));
						$vValue=trim($def[1]);
						if ($vName=='NAME') {
							$lbsDEFname=substr(trim($vValue),0,100);
						}
						if ($vName=='TITEL') {
							$lbsDEFtitle=substr(trim($vValue),0,100);
						}
						if (substr($vName,0,2)=='E#') {
							//Eingang: ID
							$tmp0=preg_replace("/[^0-9]/",'',substr($vName,2,strlen($vName)));

							//Eingang: Name
							$vTmp=explode('#init=',$vValue);
							$tmp1=substr(trim($vTmp[0]),0,100);

							//Eingang: Init-Wert
							if (count($vTmp)>1) {
								$tmp2=trim($vTmp[1]);
							} else {
								$tmp2=null;
							}

							//Eingang: Farbcode
							$cTmp=0;
							if (strpos($vName,'TRIGGER')!==false) {$cTmp=1;}
							if (strpos($vName,'OPTION')!==false) {$cTmp=2;}
							if (strpos($vName,'IMPORTANT')!==false) {$cTmp=3;}
							$tmp3=$cTmp;

							$exist=false;
							foreach ($lbsDEFin as $n) {
								if ($tmp0==$n[0]) {
									$exist=true;
									break;
								}
							}
							if (!$exist) {
								if ($tmp0>0) {
									$lbsDEFin[]=array($tmp0,$tmp1,$tmp2,$tmp3);
								} else {
									$err++;
									$errInfo.='E#'.$tmp0.': ungültige ID'."\n";
								}
							} else {
								$err++;
								$errInfo.='E#'.$tmp0.': bereits deklariert'."\n";
							}
						}
						if (substr($vName,0,2)=='A#') {
							//Ausgang: ID
							$tmp0=preg_replace("/[^0-9]/",'',substr($vName,2,strlen($vName)));
							//Ausgang: Name
							$tmp1=substr(trim($vValue),0,100);

							$exist=false;
							foreach ($lbsDEFout as $n) {
								if ($tmp0==$n[0]) {
									$exist=true;
									break;
								}
							}
							if (!$exist) {
								if ($tmp0>0) {
									$lbsDEFout[]=array($tmp0,$tmp1);
								} else {
									$err++;
									$errInfo.='A#'.$tmp0.': ungültige ID'."\n";
								}
							} else {
								$err++;
								$errInfo.='A#'.$tmp0.': bereits deklariert'."\n";
							}
						}
						if (substr($vName,0,2)=='V#') {
							//Variable: ID
							$tmp0=preg_replace("/[^0-9]/",'',substr($vName,2,strlen($vName)));
							//Variable: Init-Wert
							$tmp1=trim($vValue);

							$exist=false;
							foreach ($lbsDEFvar as $n) {
								if ($tmp0==$n[0]) {
									$exist=true;
									break;
								}
							}
							if (!$exist) {
								if ($tmp0>0) {
									$lbsDEFvar[]=array($tmp0,$tmp1);
								} else {
									$err++;
									$errInfo.='V#'.$tmp0.': ungültige ID'."\n";
								}
							} else {
								$err++;
								$errInfo.='V#'.$tmp0.': bereits deklariert'."\n";
							}
						}
					}
				}
			}
		}

		//Name vorhanden?
		if (isEmpty($lbsDEFname)) {
			$lbsDEFname='ohne Name';
		}

		//mind. 1 Eingang vorhanden? (ausser bei Textbox 12000000)
		if (count($lbsDEFin)==0 && $lbsID!="12000000") {
			$err++;
			$errInfo.='kein Eingang deklariert'."\n";
		}

		//Haupt-Funktion vorhanden?
		if (strpos($lbsLBS,'function LB_LBSID(')===false) {
			$err++;
			$errInfo.='Funktion LB_LBSID() nicht vorhanden'."\n";
		}

		//EXEC-Aufruf vorhanden?
		if (strpos($lbsLBS,"callLogicFunctionExec(")!==false || strpos($lbsLBS,"logic_callExec(")!==false) {
			$lbsEXECcall=true;
			if (isEmpty($lbsEXEC)) {	//EXEC-Call vorhanden, aber der EXEC-Abschnitt ist leer
				$err++;
				$errInfo.='EXEC-Abschnitt ist leer, jedoch erforderlich'."\n";
			}
		}

		//LBSID mit echter ID ersetzen
		$lbsLBS=str_replace('LBSID',$lbsID,$lbsLBS);
		$lbsEXEC=str_replace('LBSID',$lbsID,$lbsEXEC);

		//Syntax korrekt?
		$tmp=lbs_checkSyntax($lbsFilename);
		if ($tmp!==false) {
			$err++;
			$errInfo.='PHP-Syntaxfehler: '.$tmp."\n";
		}
				
		if (!$lbsEXECcall) {$lbsEXEC=null;}
		return array($err,$errInfo,$lbsEXECcall,$lbsDEFname,$lbsDEFin,$lbsDEFout,$lbsDEFvar,$lbsLBS,$lbsEXEC,$lbsHELP,$lbsDEFtitle);
		
	} else {
		//LBS-Datei existiert nicht, oder $lbsID ist falsch
		return false;
	}
}

function lbs_preview($id) {
	$preview='';
	$lbs=sql_getValues('edomiProject.editLogicElementDef','id,name,title,errcount','id='.$id);
	if ($lbs!==false && $lbs['errcount']==0) {

		if (!isEmpty($lbs['title'])) {$lbs['name']=$lbs['title'];}

		if ($lbs['id']==12000000) {
			//Sonderfall: Textboxen
			$preview='<div style="border-radius:3px; overflow:hidden; box-shadow:0 0 5px #404040;">';
			$preview.='<table border="0" cellspacing="0" cellpadding="1" class="app1_elContainer" style="position:relative; box-shadow:none; line-height:1; pointer-events:none;">';
			$preview.='<tr><td class="app1_elTextboxTitel">'.$lbs['name'].'</td></tr>';
			$preview.='<tr><td class="app1_divTextboxInfo" style="height:100px;">&nbsp;</td></tr>';
			$preview.='</table>';
			$preview.='</div>';
			return $preview;
		}

		$tmp=array();
		$countIn=0;
		$countOut=0;

		//Eingänge
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicElementDefIn WHERE targetid=".$lbs['id']." ORDER BY ID ASC");
		while ($n=sql_result($ss1)) {
			//Eingangsboxen:
			if ($lbs['id']<=12000005) {
				$tmp[$n['id']][0]='<td colspan="3" class="app1_elEingangsboxInput">'.$n['name'].'</td>';
			} else {
				$tmp[$n['id']][0]='<td class="app1_elInputNum col'.$n['color'].'">&#x25B8;&nbsp;E'.$n['id'].'</td><td class="app1_elInput">'.$n['name'].'</td><td class="app1_elInputValue">'.$n['value'].'</td>';
			}
			$countIn++;
		}
		sql_close($ss1);

		//Ausgänge
		$ss1=sql_call("SELECT * FROM edomiProject.editLogicElementDefOut WHERE targetid=".$lbs['id']." ORDER BY ID ASC");
		while ($n=sql_result($ss1)) {
			//Eingangsboxen:
			if ($lbs['id']<=12000005) {
				$tmp[$n['id']][1]='<td colspan="2" class="app1_elOutputNum">&nbsp;A'.$n['id'].'&nbsp;&#x25B8;</td>';
			} else {
				$tmp[$n['id']][1]='<td class="app1_elOutput">'.$n['name'].'</td><td class="app1_elOutputNum">A'.$n['id'].'&nbsp;&#x25B8;</td>';
			}
			$countOut++;
		}
		sql_close($ss1);

		//Sonderfall: Ausgangsboxen
		if ($lbs['id']>=12000010 && $lbs['id']<=12000019) {
			$tmp[1][1]='<td colspan="2" class="app1_elAusgangsboxOutput0">0 Befehle</td>';
			$countOut=1;
		}

		//HTML generieren
		$preview='<div style="border-radius:3px; overflow:hidden; box-shadow:0 0 5px #404040;">';
		$preview.='<table border="0" cellspacing="0" cellpadding="1" class="app1_elContainer" style="position:relative; box-shadow:none; line-height:1; pointer-events:none;">';
		$preview.='<tr><td colspan="5" class="app1_elTitel">'.$lbs['name'].'</td></tr>';
		for ($t=1;$t<=count($tmp);$t++) {
			$preview.='<tr>';
			if (!isset($tmp[$t][0])) {$tmp[$t][0]='<td colspan="3" style="background:transparent;">&nbsp;</td>';}
			if (!isset($tmp[$t][1])) {$tmp[$t][1]='<td colspan="2" style="background:transparent;">&nbsp;</td>';}
			if ($countIn==0) {$tmp[$t][0]='';}
			if ($countOut==0) {$tmp[$t][1]='';}
			$preview.=$tmp[$t][0].$tmp[$t][1];
			$preview.='</tr>';
		}
		$preview.='</table>';
		$preview.='</div>';
	}
	return $preview;
}

//---------------------------------------------------------------------------------------------------------------------------------------------
//GUI: Controls initialisieren
//---------------------------------------------------------------------------------------------------------------------------------------------

function initControls($cmd) {
	global $appId,$winId,$data,$dataArr,$phpdata,$phpdataArr,$sid;
	global $global_weekdays,$global_charttyp;

	if ($cmd=='initControls') {	
		//bulk-Verarbeitung von controlInitAll() (controls.js)
		$n=explode(AJAX_SEPARATOR2,$data,-1);		
		for ($t=0;$t<count($n);$t++) {
			$dataArr=explode(AJAX_SEPARATOR1,$n[$t]);
			$tmp=array_shift($dataArr);
			$data=implode(AJAX_SEPARATOR1,$dataArr);			
			initControls($tmp);
		}

	} else if ($cmd=='initControl-1000') {
		$root=explode('_',$dataArr[1]);
		
		$options=array();
		$tmp=explode(';',$dataArr[3]);
		for ($t=0; $t<count($tmp); $t++) {
			$tmp2=explode('=',$tmp[$t]);
			if (!isEmpty(trim($tmp2[0]))) {$options[trim($tmp2[0])]=$tmp2[1];}
		}
		
		$n=false;
		
		if ($root[0]==11) {
			$n=sql_getValues('edomiProject.editLogicPage','id,name,pagestatus','id='.$dataArr[2]);
			if ($n!==false) {
				if ($n['pagestatus']==0) {
					echo 'document.getElementById("'.$dataArr[0].'").innerHTML="<span style=\"color:#a0a0a0;\">'.ajaxEncode($n['name']).'</span> <span class=\"id\">'.$n['id'].'</span>";';
				} else {
					echo 'document.getElementById("'.$dataArr[0].'").innerHTML="<span style=\"color:#409000;\">'.ajaxEncode($n['name']).'</span> <span class=\"id\">'.$n['id'].'</span>";';
				}
			}

		} else if ($root[0]==12) {
			$n=sql_getValues('edomiProject.editLogicElementDef','id,name,errcount','id='.$dataArr[2]);
			if ($n!==false) {
				if (isEmpty($options['caption'])) {
					if ($n['errcount']==0) {
						echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.sql_decodeValue($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
					} else {
						echo 'document.getElementById("'.$dataArr[0].'").innerHTML="<span style=\"color:#ff0000;\">'.sql_decodeValue($n['name']).'</span> <span class=\"id\">'.$n['id'].'</span>";';
					}
				}
			}

		} else if ($root[0]==21) {
			$n=sql_getValues('edomiProject.editVisu','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==22) {
			$n=sql_getValues('edomiProject.editVisuPage','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==23) {
			$n=sql_getValues('edomiProject.editVisuUser','id,login','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['login']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==24) {
			$n=sql_getValues('edomiProject.editVisuElementDef','id,name,styletyp,s1,s2','id='.$dataArr[2]);
			if ($n!==false) {
				if ($n['styletyp']==1) {$tmp=' <span class=\"varItem\" style=\"color:#ff0000;\">'.ajaxEncode($n['s1']).' &gt; '.ajaxEncode($n['s2']).'</span>';} else {$tmp='';}
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>'.$tmp.'";';
			}

		} else if ($root[0]==25) {
			$n=sql_getValues('edomiProject.editVisuBGcol','id,name,color','id='.$dataArr[2]);
			if ($n!==false) {
				if (strpos($n['color'],'{')===false) {
					echo 'document.getElementById("'.$dataArr[0].'").innerHTML="<span class=\"colorPreview1\" style=\"background:'.ajaxEncode($n['color']).';\"></span> '.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
				} else {
					echo 'document.getElementById("'.$dataArr[0].'").innerHTML="<span class=\"colorPreview2\"></span> '.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
				}
			}

		} else if ($root[0]==26) {
			$n=sql_getValues('edomiProject.editVisuFGcol','id,name,color','id='.$dataArr[2]);
			if ($n!==false) {
				if (strpos($n['color'],'{')===false) {
					echo 'document.getElementById("'.$dataArr[0].'").innerHTML="<span class=\"colorPreview1\" style=\"background:'.ajaxEncode($n['color']).';\"></span> '.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
				} else {
					echo 'document.getElementById("'.$dataArr[0].'").innerHTML="<span class=\"colorPreview2\"></span> '.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
				}
			}

		} else if ($root[0]==27) {
			$n=sql_getValues('edomiProject.editVisuAnim','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==28) {
			$n=sql_getValues('edomiProject.editVisuImg','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==29) {
			$n=sql_getValues('edomiProject.editVisuSnd','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==30) {
			$n=sql_getValues('edomiProject.editKo','id,ga,name,gatyp','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"idGa'.$n['gatyp'].'\">'.ajaxEncode($n['ga']).'</span>";';
			}

		} else if ($root[0]==40) {
			$n=sql_getValues('edomiProject.editScene','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==50) {
			$n=sql_getValues('edomiProject.editArchivKo','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==60) {
			$n=sql_getValues('edomiProject.editArchivMsg','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==70) {
			$n=sql_getValues('edomiProject.editIp','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==75) {
			$n=sql_getValues('edomiProject.editIr','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==81) {
			$n=sql_getValues('edomiProject.editCam','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==82) {
			$n=sql_getValues('edomiProject.editArchivCam','id,camid,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==83) {
			$n=sql_getValues('edomiProject.editCamView','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==90) {
			$n=sql_getValues('edomiProject.editSequence','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==95) {
			$n=sql_getValues('edomiProject.editMacro','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==100) {
			$n=sql_getValues('edomiProject.editTimer','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==101) {
			$n=sql_getValues('edomiProject.editAgenda','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==110) {
			$n=sql_getValues('edomiProject.editAws','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==120) {
			$n=sql_getValues('edomiProject.editEmail','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==125) {
			$n=sql_getValues('edomiProject.editPhoneBook','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==127) {
			$n=sql_getValues('edomiProject.editArchivPhone','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==130) {
			$n=sql_getValues('edomiProject.editChart','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==140) {
			$n=sql_getValues('edomiProject.editHttpKo','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}

		} else if ($root[0]==150) {
			$n=sql_getValues('edomiProject.editVisuFont','id,name','id='.$dataArr[2]);
			if ($n!==false) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>";';
			}
		}


		if ($n===false) {
			if (isEmpty($options['caption'])) {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="<span style=\"color:#a0a0a0;\">&lt;leer&gt;</span>";';
			} else {
				echo 'document.getElementById("'.$dataArr[0].'").innerHTML="'.$options['caption'].'";';
			}
		}

	} else if ($cmd=='initControl-1001') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		$ss1=sql_call("SELECT * FROM edomiProject.editSceneList WHERE (targetid=".$dataArr[2].") ORDER BY id ASC");
		while ($item=sql_result($ss1)) {
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
<?
			if ($item['learngaid']>0) {
?>
				item.innerHTML="&bull; <span class='varItem'><?echo getGaInfo(1,$item['gaid']);?></span> &gt; <span class='varItem'><?ajaxEcho($item['gavalue']);?></span> &middot; Lern-KO <span class='varItem'><?echo getGaInfo(1,$item['learngaid']);?></span>";
<?
			} else {
?>
				item.innerHTML="&bull; <span class='varItem'><?echo getGaInfo(1,$item['gaid']);?></span> &gt; <span class='varItem'><?ajaxEcho($item['gavalue']);?></span>";
<?
			}
?>
			item.dataset.cm0='ajax("deleteItem",1001,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?

	} else if ($cmd=='initControl-1003') {
		echo 'clearObject("'.$dataArr[0].'",0);';

		if (strpos($dataArr[3],'-dynDesigns')===false) {$dynDesigns=false;} else {$dynDesigns=true;}
		if (strpos($dataArr[3],'-editSheet')===false) {$editSheet=false;} else {$editSheet=true;}
		$empty=true;

		if ($editSheet) {	//Vorlage editieren
			
			$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (id=".$dataArr[2].")");
			while ($item=sql_result($ss1)) {
				$empty=false;
?>
				var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
				item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
<?
				if ($item['styletyp']==0) {	//Defaultdesign
?>
					item.innerHTML="&bull; individuell";
<?				
				} else {					//dynamisches Design
?>
					item.innerHTML="&bull; <span class='varItem'><?ajaxEcho($item['s1']);?> &gt; <?ajaxEcho($item['s2']);?></span> individuell";
<?				
				}
			}
		
		} else {	//Visuelement editieren
		
			if ($dynDesigns) {	//Liste: Dynamische Designs
	
				$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (targetid=".$dataArr[2]." AND styletyp=1) ORDER BY id ASC");
				while ($item=sql_result($ss1)) {
					$empty=false;
?>
					var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
					item.className="controlListItem";
					item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
<?
					if ($item['defid']>0) {	//Designvorlage
					
						$ss2=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (id=".$item['defid'].")");
						if ($itemDef=sql_result($ss2)) {
							if (!isEmpty($item['s1'])) {$itemDef['s1']=$item['s1'];}
							if (!isEmpty($item['s2'])) {$itemDef['s2']=$item['s2'];}
?>
							item.innerHTML="&bull; <span class='varItem'><?ajaxEcho($itemDef['s1']);?> &gt; <?ajaxEcho($itemDef['s2']);?></span> <span class='varItem'><?ajaxEcho($itemDef['name']);?> <span class='id'><?echo $itemDef['id'];?></span></span>";
<?
						} else {
?>
							item.innerHTML="&bull; <span style='color:#ffffff; background:#ff0000; border:1px solid #ff0000;'>[Designvorlage ungültig!]</span>";
<?
						}
		
					} else {				//manuelle Definition
?>
						item.innerHTML="&bull; <span class='varItem'><?ajaxEcho($item['s1']);?> &gt; <?ajaxEcho($item['s2']);?></span> individuell";
<?				
					}
					if ($dynDesigns) {
?> 
						item.dataset.cm3='ajax("duplicateItem",1003,"","<?echo $data;?>","<?echo $item['id'];?>");';
						item.dataset.cm0='ajax("deleteItem",1003,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
					}			
				}
		
			} else {		//Auswahl: Defaultdesign
	
				$ss1=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (targetid=".$dataArr[2]." AND styletyp=0)");
				if ($item=sql_result($ss1)) {
					$empty=false;
?>
					var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
					item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
<?
					if ($item['defid']>0) {	//Designvorlage
						$ss2=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (id=".$item['defid'].")");
						if ($itemDef=sql_result($ss2)) {
?>
							item.innerHTML="&bull; <span class='varItem'><?ajaxEcho($itemDef['name']);?> <span class='id'><?echo $itemDef['id'];?></span></span>";
<?
						} else {
?>
							item.innerHTML="&bull; <span style='color:#ffffff; background:#ff0000; border:1px solid #ff0000;'>[Designvorlage ungültig!]</span>";
<?
						}
					} else {				//manuelle Definition	
?>
						item.innerHTML="&bull; individuell";
<?				
					}
				}
	
			}

		}

		if ($dynDesigns && (!$editSheet)) {
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
			item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?
		} else if ($empty) {
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
			item.innerHTML="<span style='color:#a0a0a0;'>&lt;leer&gt;</span>";
<?
		}


	} else if ($cmd=='initControl-1007') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		if ($dataArr[5]=='editLogicCmdList') {$ss1=sql_call("SELECT * FROM edomiProject.".$dataArr[5]." WHERE (targetid=".$dataArr[2].") ORDER BY id ASC");}
		if ($dataArr[5]=='editVisuCmdList') {$ss1=sql_call("SELECT * FROM edomiProject.".$dataArr[5]." WHERE (targetid=".$dataArr[2].") ORDER BY id ASC");}
		if ($dataArr[5]=='editSequenceList') {$ss1=sql_call("SELECT * FROM edomiProject.".$dataArr[5]." WHERE (targetid=".$dataArr[2].") ORDER BY sort ASC, id ASC");}
		if ($dataArr[5]=='editMacroCmdList') {$ss1=sql_call("SELECT * FROM edomiProject.".$dataArr[5]." WHERE (targetid=".$dataArr[2].") ORDER BY id ASC");}
		while ($item=sql_result($ss1)) {
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
			<?if ($dataArr[5]=='editSequenceList') {?>
				item.innerHTML="&bull; <?echo getCommandData($dataArr[5],$item['id']);?> + <span class='varItem'><?echo $item['delay'];?>s</span> warten";
			<?} else {?>
				item.innerHTML="&bull; <?echo getCommandData($dataArr[5],$item['id']);?>";
			<?}?>
			item.dataset.cm0='ajax("deleteItem",1007,"","<?echo $data;?>","<?echo $item['id'];?>");';
			<?if ($dataArr[5]=='editSequenceList') {?>
				item.dataset.cm1='ajax("sortDecItem",1007,"","<?echo $data;?>","<?echo $item['id'];?>");';
				item.dataset.cm2='ajax("sortIncItem",1007,"","<?echo $data;?>","<?echo $item['id'];?>");';
			<?}?>
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?

	} else if ($cmd=='initControl-1008') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		$ss1=sql_call("SELECT * FROM edomiProject.editChartList WHERE (targetid=".$dataArr[2].") ORDER BY id ASC");
		while ($item=sql_result($ss1)) {

			//Farbe Graph 1:
			$col1='';
			$tmp=sql_getValue('edomiProject.editVisuFGcol','color','id='.$item['s1']);
			if (strpos($tmp,'{')===false) {
				$col1="<span class='colorPreview1' style='background:".ajaxEncode($tmp).";'></span>"; 
			} else {
				$col1="<span class='colorPreview2'></span>"; 
			}
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
			item.innerHTML="&bull; <?echo $col1;?> Datenarchiv <span class='varItem'><?echo getArchivInfo('editArchivKo',$item['archivkoid']);?></span> / <span class='varItem'><?if ($item['ystyle']==0) {echo "<span style='color:#0000ff;'>"; ajaxEcho($item['titel']); echo "</span>, ";}?> <?echo $global_charttyp[$item['charttyp']];?>, <?ajaxEcho($item['s3']);?> px</span>";
			item.dataset.cm0='ajax("deleteItem",1008,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?

	} else if ($cmd=='initControl-1009') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		$ss1=sql_call("SELECT * FROM edomiProject.editAwsList WHERE (targetid=".$dataArr[2].") ORDER BY id ASC");
		while ($item=sql_result($ss1)) {
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
<?
			if (isEmpty($item['gavalue1']) && isEmpty($item['gavalue2'])) {
?>
				item.innerHTML="&bull; <span class='varItem'><?echo getGaInfo(1,$item['gaid']);?></span>";
<?
			} else {
?>
				item.innerHTML="&bull; <span class='varItem'><?echo getGaInfo(1,$item['gaid']);?></span> &gt; <span class='varItem'><?ajaxEcho($item['gavalue1']);?></span> &gt; <span class='varItem'><?ajaxEcho($item['gavalue2']);?></span>";
<?
			}
?>
			item.dataset.cm0='ajax("deleteItem",1009,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?

	} else if ($cmd=='initControl-1017') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		$ss1=sql_call("SELECT * FROM edomiProject.editVisuUserList WHERE (visuid=".$dataArr[2].") ORDER BY id ASC");
		while ($item=sql_result($ss1)) {
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
			item.innerHTML="&bull; <span class='varItem'><?echo getVisuUserInfo($item['targetid']);?></span>";
			item.dataset.cm0='ajax("deleteItem",1017,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="Visuaccount hinzufügen...";
<?

	} else if ($cmd=='initControl-1019') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		$ss1=sql_call("SELECT * FROM edomiProject.editTimerData WHERE (targetid=".$dataArr[2].") ORDER BY id ASC");
		while ($item=sql_result($ss1)) {
			$days='';
			for ($t=0;$t<7;$t++) {
				if ($item['d'.$t]==1) {$days.="<span style='color:#40a000;'>".substr($global_weekdays[$t],0,2)."</span> ";} else {$days.="<span style='color:#c0c0c0;'>".substr($global_weekdays[$t],0,2)."</span> ";}
			}
			$noDate=true;
			if (isEmpty($item['day1'])) 	{$item['day1']="<span style='color:#c0c0c0;'>&middot;&middot;</span>";} else {$item['day1']=sprintf("%02d",$item['day1']); $noDate=false;}
			if (isEmpty($item['month1'])) 	{$item['month1']="<span style='color:#c0c0c0;'>&middot;&middot;</span>";} else {$item['month1']=sprintf("%02d",$item['month1']); $noDate=false;}
			if (isEmpty($item['year1'])) 	{$item['year1']="<span style='color:#c0c0c0;'>&middot;&middot;&middot;&middot;</span>";} else {$item['year1']=sprintf("%04d",$item['year1']); $noDate=false;}
			if (isEmpty($item['day2'])) 	{$item['day2']="<span style='color:#c0c0c0;'>&middot;&middot;</span>";} else {$item['day2']=sprintf("%02d",$item['day2']); $noDate=false;}
			if (isEmpty($item['month2'])) 	{$item['month2']="<span style='color:#c0c0c0;'>&middot;&middot;</span>";} else {$item['month2']=sprintf("%02d",$item['month2']); $noDate=false;}
			if (isEmpty($item['year2'])) 	{$item['year2']="<span style='color:#c0c0c0;'>&middot;&middot;&middot;&middot;</span>";} else {$item['year2']=sprintf("%04d",$item['year2']); $noDate=false;}

			if ($noDate) {
				$tmp='';
			} else {
				$tmp=' &nbsp;&middot;&nbsp; '.$item['day1'].'.'.$item['month1'].'.'.$item['year1'].' '.(($item['mode']==0)?'&middot;':'&gt;').' '.$item['day2'].'.'.$item['month2'].'.'.$item['year2'];
			}
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
			item.innerHTML="&bull; <span class='varItem'><?echo sprintf("%02d",$item['hour']).':'.sprintf("%02d",$item['minute']).' Uhr &nbsp;&middot;&nbsp; '.trim($days).$tmp;?></span> &gt; <span class='varItem'><?echo getMacroInfo($item['cmdid']);?></span>";
			item.dataset.cm0='ajax("deleteItem",1019,"","<?echo $data;?>","<?echo $item['id'];?>");';
			item.dataset.cm3='ajax("duplicateItem",1019,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?
	} else if ($cmd=='initControl-1022') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		$ss1=sql_call("SELECT * FROM edomiProject.editAgendaData WHERE (targetid=".$dataArr[2].") ORDER BY id ASC");
		while ($item=sql_result($ss1)) {
			$info1='';
			if ($item['step']>0) {
				$info1=' &middot; alle '.$item['step'];
				if ($item['unit']==0) {$info1.=' Tage';}
				if ($item['unit']==1) {$info1.=' Wochen';}
				if ($item['unit']==2) {$info1.=' Monate';}
				if ($item['unit']==3) {$info1.=' Jahre';}
				if (!isEmpty($item['date2'])) {$info1.=' bis '.sql_getDate($item['date2']);}
			}
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
			item.innerHTML="&bull; <span class='varItem'><?echo sql_getDate($item['date1']);?> &middot; <?echo sprintf("%02d",$item['hour']).':'.sprintf("%02d",$item['minute']);?> Uhr <span style='color:#40a000;'><?echo $info1;?></span></span>&nbsp;&gt; <span class='varItem'><?echo getMacroInfo($item['cmdid']);?></span> &middot;&nbsp;<span class='varItem' style='color:#0000ff;'><?ajaxEcho($item['name']);?></span>";
			item.dataset.cm0='ajax("deleteItem",1022,"","<?echo $data;?>","<?echo $item['id'];?>");';
			item.dataset.cm3='ajax("duplicateItem",1022,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?

	} else if ($cmd=='initControl-1023') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		$ss1=sql_call("SELECT * FROM edomiProject.editTimerMacroList WHERE (timerid=".$dataArr[2].") ORDER BY sort ASC, id ASC");
		while ($item=sql_result($ss1)) {
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
			item.innerHTML="&bull; <span class='varItem'><?echo getMacroInfo($item['targetid']);?></span>";
			item.dataset.cm0='ajax("deleteItem",1023,"","<?echo $data;?>","<?echo $item['id'];?>");';
			item.dataset.cm1='ajax("sortDecItem",1023,"","<?echo $data;?>","<?echo $item['id'];?>");';
			item.dataset.cm2='ajax("sortIncItem",1023,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?

	} else if ($cmd=='initControl-1024') {
		echo 'clearObject("'.$dataArr[0].'",0);';
		$ss1=sql_call("SELECT * FROM edomiProject.editAgendaMacroList WHERE (agendaid=".$dataArr[2].") ORDER BY sort ASC, id ASC");
		while ($item=sql_result($ss1)) {
?>
			var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-<?echo $item['id'];?>");
			item.className="controlListItem";
			item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=<?echo $item['id'];?>; controlClick("<?echo $dataArr[0];?>");');
			item.innerHTML="&bull; <span class='varItem'><?echo getMacroInfo($item['targetid']);?></span>";
			item.dataset.cm0='ajax("deleteItem",1024,"","<?echo $data;?>","<?echo $item['id'];?>");';
			item.dataset.cm1='ajax("sortDecItem",1024,"","<?echo $data;?>","<?echo $item['id'];?>");';
			item.dataset.cm2='ajax("sortIncItem",1024,"","<?echo $data;?>","<?echo $item['id'];?>");';
<?
		}
?>
		var item=createNewDiv("<?echo $dataArr[0];?>","<?echo $dataArr[0];?>-newitem");
		item.className="controlListItem";
		item.setAttribute('onMouseDown','document.getElementById("<?echo $dataArr[0];?>").dataset.itemid=-1; controlClick("<?echo $dataArr[0];?>");');
		item.innerHTML="<div style='padding:2px;'><b>+ Eintrag hinzufügen...</b></div>";
<?
	}

}


/*
------------------------------------------------------------------------------------------------------------------------------------------------------
GUI: Auswahlfelder
------------------------------------------------------------------------------------------------------------------------------------------------------
*/

function getGaInfo($mode,$id) {
	//$mode: 0=Logikeditor (LBS-Eingänge), 1=alles andere
	$ss1=sql_call("SELECT id,name,ga,gatyp FROM edomiProject.editKo WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		if ($mode==0) {return '<span class=\"idGa'.$n['gatyp'].'\">'.ajaxEncode($n['ga']).'</span>'.SEPARATOR1.ajaxEncode($n['name']);}
		if ($mode==1) {return ajaxEncode($n['name']).' <span class=\"idGa'.$n['gatyp'].'\">'.ajaxEncode($n['ga']).'</span>';}
	} else {
		if ($mode==0) {return '<span class=\"id\">-?-</span>'.SEPARATOR1.'-?-';}
		if ($mode==1) {return '<span class=\"id\">-?-</span>';}
	}
}

function getLbsInstanceInfo($id,$item=0,$mode=-1) {
	//OPTIONAL: $item: Nr. des Eingangs/Ausgangs, $mode: 0=Eingang, 1=Ausgang
	$n=sql_getValues('edomiProject.editLogicElement','id,functionid','id='.$id);
	if ($n!==false) {
		$itemInfo='';

		$lbs=sql_getValues('edomiProject.editLogicElementDef','id,name','id='.$n['functionid']);
		if ($lbs!==false) {

			$itemInfo=ajaxValue($lbs['name'],false).' <span class=\"id\">'.$n['id'].'</span>';

			if ($item>0 && $mode>=0) {
				if ($mode==0) {
					$tmp=sql_getValues('edomiProject.editLogicElementDefIn','id,name','targetid='.$lbs['id'].' AND id='.$item);
					$itemInfo.=' &gt; '.ajaxValue($tmp['name'],false).' <span class=\"id\">E'.$tmp['id'].'</span>';
				} else {
					$tmp=sql_getValues('edomiProject.editLogicElementDefOut','id,name','targetid='.$lbs['id'].' AND id='.$item);
					$itemInfo.=' &gt; '.ajaxValue($tmp['name'],false).' <span class=\"id\">A'.$tmp['id'].'</span>';
				}
			}

		} else {
			$itemInfo='-?-'.' <span class=\"id\">'.$n['id'].'</span>';
		}

		return $itemInfo;
	}
	return '-?-';
}

function getCamInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editCam WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getCamViewInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editCamView WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getSceneInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editScene WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getArchivInfo($archivDb,$id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.".$archivDb." WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getSequenceInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editSequence WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getMacroInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editMacro WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getTimerInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editTimer WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getIrInfo($id) {
	$ss1=sql_call("SELECT id,folderid,name FROM edomiProject.editIr WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
/*
	### Mit Ordner (funktioniert, ist aber inkonsequent - alle anderen Commands zeigen keine Ordner an...)
	$ss1=sql_call("SELECT id,folderid,name FROM edomiProject.editIr WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		$ss2=sql_call("SELECT name,path FROM edomiProject.editRoot WHERE (id=".$n['folderid'].")");
		if ($nn=sql_result($ss2)) {
			if ($nn['path']=='/') {
				return '<b>'.ajaxEncode($n['name']).'</b> <span class=\"id\">'.$n['id'].'</span>';
			} else {
				return ajaxEncode($nn['name']).'/'.ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
			}
		}
	} else {
		return '-?-';
	}
*/
}

function getEmailInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editEmail WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getPhoneInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editPhoneBook WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getChartInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editChart WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getVisuInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editVisu WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getVisuSoundInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editVisuSnd WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getVisuPageInfo($id) {
	$ss1=sql_call("SELECT id,name FROM edomiProject.editVisuPage WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['name']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getVisuUserInfo($id) {
	$ss1=sql_call("SELECT id,login FROM edomiProject.editVisuUser WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		return ajaxEncode($n['login']).' <span class=\"id\">'.$n['id'].'</span>';
	} else {
		return '-?-';
	}
}

function getCommandData($archivDb,$id) {
	//Befehle: Logik, Visu, Sequenzen
	$ss1=sql_call("SELECT * FROM edomiProject.".$archivDb." WHERE (id=".$id.")");
	if ($n=sql_result($ss1)) {
		if ($n['outmode']==1) {return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Eingangswert (E1 oder E2) zuweisen';}
		if ($n['outmode']==2) {return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Wert <span class=\"varItem\">'.ajaxEncode($n['outvalue']).'</span> zuweisen';}
		if ($n['outmode']==3) {return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Wert von <span class=\"varItem\">'.getGaInfo(1,$n['outvalue']).'</span> zuweisen';}
		if ($n['outmode']==4) {return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Wechseln zwischen 0 und <span class=\"varItem\">'.ajaxEncode($n['outvalue']).'</span>';}
		if ($n['outmode']==5) {$tmp=array(1=>'addieren',-1=>'subtrahieren'); return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Rasterwert <span class=\"varItem\">'.$tmp[$n['outvalue']].'</span>';}
		if ($n['outmode']==6) {return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Wechseln zwischen 0 und 1 mit Status-KO <span class=\"varItem\">'.getGaInfo(1,$n['outvalue']).'</span>';}
		if ($n['outmode']==7) {return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Wert <span class=\"varItem\">'.ajaxEncode($n['outvalue']).'</span> addieren';}
		if ($n['outmode']==8) {return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Abfragen (Read-Request)';}
		if ($n['outmode']==9) {return 'KO <span class=\"varItem\">'.getGaInfo(1,$n['outid']).'</span> &gt; Wertliste vor/zurück: <span class=\"varItem\">'.ajaxEncode($n['outvalue']).'</span>';}

		if ($n['outmode']==10) {$tmp=array(0=>'Abrufen',1=>'Lernen'); return 'Szene <span class=\"varItem\">'.getSceneInfo($n['outid']).'</span> &gt; <span class=\"varItem\">'.$tmp[$n['outvalue']].'</span>';}
		if ($n['outmode']==11) {$tmp=array(0=>'Abrufen',1=>'Stoppen'); return 'Sequenz <span class=\"varItem\">'.getSequenceInfo($n['outid']).'</span> &gt; <span class=\"varItem\">'.$tmp[$n['outvalue']].'</span>';}
		if ($n['outmode']==17) {return 'Makro <span class=\"varItem\">'.getMacroInfo($n['outid']).'</span> &gt; Ausführen';}

		if ($n['outmode']==12) {return 'Kameraarchiv <span class=\"varItem\">'.getArchivInfo('editArchivCam',$n['outid']).'</span> &gt; Kamerabild hinzufügen';}
		if ($n['outmode']==13) {return 'Datenarchiv <span class=\"varItem\">'.getArchivInfo('editArchivKo',$n['outid']).'</span> &gt; Eingangswert (E1 oder E2) hinzufügen';}
		if ($n['outmode']==14) {return 'Meldungsarchiv <span class=\"varItem\">'.getArchivInfo('editArchivMsg',$n['outid']).'</span> &gt; Eingangswert (E1 oder E2) hinzufügen';}
		if ($n['outmode']==40) {return 'Datenarchiv <span class=\"varItem\">'.getArchivInfo('editArchivKo',$n['outid']).'</span> &gt; Wert <span class=\"varItem\">'.ajaxEncode($n['outvalue']).'</span> hinzufügen';}
		if ($n['outmode']==41) {return 'Meldungsarchiv <span class=\"varItem\">'.getArchivInfo('editArchivMsg',$n['outid']).'</span> &gt; Meldung <span class=\"varItem\">'.ajaxEncode($n['outvalue']).'</span> hinzufügen';}

		if ($n['outmode']==50) {
			if ($n['outvalue']==0) {return 'Datenarchiv <span class=\"varItem\">'.getArchivInfo('editArchivKo',$n['outid']).'</span> &gt; Neusten Eintrag entfernen';}
			if ($n['outvalue']==1) {return 'Datenarchiv <span class=\"varItem\">'.getArchivInfo('editArchivKo',$n['outid']).'</span> &gt; Ältesten Eintrag entfernen';}
			if ($n['outvalue']==2) {return 'Datenarchiv <span class=\"varItem\">'.getArchivInfo('editArchivKo',$n['outid']).'</span> &gt; Alle Einträge entfernen(!)';}
		}
		if ($n['outmode']==51) {
			if ($n['outvalue']==0) {return 'Meldungsarchiv <span class=\"varItem\">'.getArchivInfo('editArchivMsg',$n['outid']).'</span> &gt; Neuste Meldung entfernen';}
			if ($n['outvalue']==1) {return 'Meldungsarchiv <span class=\"varItem\">'.getArchivInfo('editArchivMsg',$n['outid']).'</span> &gt; Älteste Meldung entfernen';}
			if ($n['outvalue']==2) {return 'Meldungsarchiv <span class=\"varItem\">'.getArchivInfo('editArchivMsg',$n['outid']).'</span> &gt; Alle Meldungen entfernen(!)';}
		}
		if ($n['outmode']==52) {
			if ($n['outvalue']==0) {return 'Kameraarchiv <span class=\"varItem\">'.getArchivInfo('editArchivCam',$n['outid']).'</span> &gt; Neustes Kamerabild entfernen';}
			if ($n['outvalue']==1) {return 'Kameraarchiv <span class=\"varItem\">'.getArchivInfo('editArchivCam',$n['outid']).'</span> &gt; Ältestes Kamerabild entfernen';}
			if ($n['outvalue']==2) {return 'Kameraarchiv <span class=\"varItem\">'.getArchivInfo('editArchivCam',$n['outid']).'</span> &gt; Alle Kamerabilder entfernen(!)';}
		}
		if ($n['outmode']==53) {
			if ($n['outvalue']==0) {return 'Anrufarchiv <span class=\"varItem\">'.getArchivInfo('editArchivPhone',$n['outid']).'</span> &gt; Neusten Eintrag entfernen';}
			if ($n['outvalue']==1) {return 'Anrufarchiv <span class=\"varItem\">'.getArchivInfo('editArchivPhone',$n['outid']).'</span> &gt; Ältesten Eintrag entfernen';}
			if ($n['outvalue']==2) {return 'Anrufarchiv <span class=\"varItem\">'.getArchivInfo('editArchivPhone',$n['outid']).'</span> &gt; Alle Einträge entfernen(!)';}
		}

		if ($n['outmode']==15) {return 'HTTP/UDP/SHELL <span class=\"varItem\">'.getArchivInfo('editIp',$n['outid']).'</span> &gt; Ausführen';}
		if ($n['outmode']==16) {$tmp=array(1=>'Kanal 1',2=>'Kanal 2',3=>'Kanal 1 und 2'); return 'IR-Befehl <span class=\"varItem\">'.getIrInfo($n['outid']).'</span> &gt; Über <span class=\"varItem\">'.$tmp[$n['outvalue']].'</span> senden';}
		if ($n['outmode']==20) {return 'Email <span class=\"varItem\">'.getEmailInfo($n['outid']).'</span> &gt; Senden';}
		if ($n['outmode']==22) {
			if ($n['outid']>0) {
				if ($n['outvalue']>0) {
					return 'Telefonbucheintrag <span class=\"varItem\">'.getPhoneInfo($n['outid']).'</span> &gt; Anrufen und nach <span class=\"varItem\">'.ajaxEncode($n['outvalue']).' Sekunden</span> auflegen';
				} else {
					return 'Telefonbucheintrag <span class=\"varItem\">'.getPhoneInfo($n['outid']).'</span> &gt; Anrufen und nicht(!) auflegen';
				}
			}
			if ($n['outid']==0) {return 'Telefonanruf beenden (auflegen)';}
		}

		if ($n['outmode']==21) {
			if ($n['outvalue']==0) {return 'Visuseite <span class=\"varItem\">'.getVisuPageInfo($n['outid']).'</span> &gt; Aufrufen (alle Accounts)';}
			if ($n['outvalue']>0) {return 'Visuseite <span class=\"varItem\">'.getVisuPageInfo($n['outid']).'</span> &gt; Aufrufen (Visuaccount <span class=\"varItem\">'.getVisuUserInfo($n['outvalue']).'</span>)';}
		}
		if ($n['outmode']==28) {
			if ($n['outvalue']==0) {return 'Visu <span class=\"varItem\">'.getVisuInfo($n['outid']).'</span> &gt; Popups schließen (alle Accounts)';}
			if ($n['outvalue']>0) {return 'Visu <span class=\"varItem\">'.getVisuInfo($n['outid']).'</span> &gt; Popups schließen (Visuaccount <span class=\"varItem\">'.getVisuUserInfo($n['outvalue']).'</span>)';}
		}
		if ($n['outmode']==23) {
			if ($n['outid']==0 && $n['outvalue']==0) 	{return 'Visu/Visuaccount &gt; Logout aller Accounts (für alle Visus)';}
			if ($n['outid']==0 && $n['outvalue']>0) 	{return 'Visu/Visuaccount &gt; Logout des Accounts <span class=\"varItem\">'.getVisuUserInfo($n['outvalue']).'</span> (für alle Visus)';}
			if ($n['outid']>0 && $n['outvalue']==0) 	{return 'Visu/Visuaccount &gt; Logout der Visu <span class=\"varItem\">'.getVisuInfo($n['outid']).'</span> (alle Accounts)';}
			if ($n['outid']>0 && $n['outvalue']>0) 		{return 'Visu/Visuaccount &gt; Logout der Visu <span class=\"varItem\">'.getVisuInfo($n['outid']).'</span> (Account <span class=\"varItem\">'.getVisuUserInfo($n['outvalue']).'</span>)';}
		}
		if ($n['outmode']==24) {
			if ($n['outvalue']==0)	{return 'Visu <span class=\"varItem\">'.getVisuInfo($n['outid']).'</span> &gt; Tonausgabe stoppen';}
			if ($n['outvalue']>0) 	{return 'Visu <span class=\"varItem\">'.getVisuInfo($n['outid']).'</span> &gt; Ton <span class=\"varItem\">'.getVisuSoundInfo($n['outvalue']).'</span> abspielen';}
		}
		if ($n['outmode']==25) {
			if ($n['outvalue']==0)	{return 'Visuaccount <span class=\"varItem\">'.getVisuUserInfo($n['outid']).'</span> &gt; Tonausgabe stoppen';}
			if ($n['outvalue']>0) 	{return 'Visuaccount <span class=\"varItem\">'.getVisuUserInfo($n['outid']).'</span> &gt; Ton <span class=\"varItem\">'.getVisuSoundInfo($n['outvalue']).'</span> abspielen';}
		}
		if ($n['outmode']==26) {
			if (isEmpty($n['outvalue'])) {
				return 'Visu <span class=\"varItem\">'.getVisuInfo($n['outid']).'</span> &gt; Sprachausgabe stoppen';
			} else {
				return 'Visu <span class=\"varItem\">'.getVisuInfo($n['outid']).'</span> &gt; Sprachausgabe: <span class=\"varItem\">'.ajaxEncode($n['outvalue']).'</span>';
			}
		}
		if ($n['outmode']==27) {
			if (isEmpty($n['outvalue'])) {
				return 'Visuaccount <span class=\"varItem\">'.getVisuUserInfo($n['outid']).'</span> &gt; Sprachausgabe stoppen';
			} else {
				return 'Visuaccount <span class=\"varItem\">'.getVisuUserInfo($n['outid']).'</span> &gt; Sprachausgabe: <span class=\"varItem\">'.ajaxEncode($n['outvalue']).'</span>';
			}
		}
		if ($n['outmode']==30) {$tmp=array(1=>'Neustarten',2=>'Server neustarten',3=>'Server herunterfahren',4=>'Pausieren',9=>'Autobackup erstellen'); return 'EDOMI &gt; <span class=\"varItem\">'.$tmp[$n['outid']].'</span>';}
	} else {
		return '-?-';
	}
}



/*
------------------------------------------------------------------------------------------------------------------------------------------------------
Diverses
------------------------------------------------------------------------------------------------------------------------------------------------------
*/

function print_Calendar($month,$year,$checkMode,$filter,$multi=false) {
	global $global_weekdays,$global_months;
	$now=date('d.m.Y');
	$d0=date('d.m.Y',strtotime('01.'.$month.'.'.$year));

	$r="<table width='100%' border='0' cellpadding='2' cellspacing='1' bgcolor='#ffffff'>";
	$r.="<tr align='center' bgcolor='#a0a0a0'><td style='color:#ffffff;' colspan='7'>".$month." &middot; ".$global_months[$month-1]."</td></tr>";
		
	$r.="<tr align='center' bgcolor='#d9d9d9'>";
	for ($tt=0;$tt<7;$tt++) {
		$r.="<td ".(($tt>=5)?"style='color:#d90000;'":"").">".substr($global_weekdays[$tt],0,2)."</td>";
	}
	$r.="</tr>";

	$row=0;
	$r.="<tr align='center'>";
	$wday=date('N',strtotime($d0));
	for ($t=1;$t<$wday;$t++) {$r.="<td ".(($t>5)?"style='color:#d90000;'":"").">&nbsp;</td>";}

	do {
		$day=date('d',strtotime($d0));
		$wday=date('N',strtotime($d0));
		$highlight=0;

		if ($checkMode==1) {
			if ($multi) {
				for ($t=0;$t<count($filter);$t++) {
					if (checkZSU_date($d0,$filter[$t])) {
						if ($filter[$t][14]==0) {$highlight|=1;} else {$highlight|=2;}
					}
				}
			} else if (checkZSU_date($d0,$filter)) {
				if ($filter[14]==0) {$highlight=1;} else {$highlight=2;}
			}
		} else if ($checkMode==2) {
			if ($multi) {
				for ($t=0;$t<count($filter);$t++) {
					if (previewTSU_date($d0,$filter[$t])) {
						if ($filter[$t][4]==0) {$highlight|=1;} else {$highlight|=2;}
					}
				}
			} else if (previewTSU_date($d0,$filter)) {
				if ($filter[4]==0) {$highlight=1;} else {$highlight=2;}
			}
		}
		
		if ($highlight==1) {$bgcolor="background:#e09090;";}		
		else if ($highlight==2) {$bgcolor="background:#90e000;";}		
		else if ($highlight==3) {$bgcolor="background:-webkit-repeating-linear-gradient(45deg,#90e000 0%,#90e000 50%,#e09090 50%,#e09090 100%);";}		
		else {$bgcolor="";}
		
		$r.="<td  style='".$bgcolor." ".(($wday>5)?"color:#d90000;":"")."'>".(($d0==$now)?"<div style='display:block; color:#ffffff; background:#595959; border-radius:3px;'>".intval($day)."</div>":intval($day))."</td>";
		
		if ($wday==7) {
			$r.="</tr><tr align='center'>";
			$row++;
		}		
		
		$d0=date('d.m.Y',strtotime($d0.' +1 day'));
	} while ($month==intval(date('m',strtotime($d0))));

	for ($t=($wday+1);$t<=7;$t++) {$r.="<td ".(($t>5)?"style='color:#d90000;'":"").">&nbsp;</td>";}
	if ($wday==7) {$r.="<td colspan='7'>&nbsp;</td></tr>";} else {$r.="</tr>";}
	if ($row<5) {$r.="<tr><td colspan='7'>&nbsp;</td></tr>";}
	$r.="</table>";
	return $r;
}

function helpToHtml($winId,$helpFn,$newWin=false) {
	//wandelt einen Hilfe-Text in HTML um, so dass dieser per Ajax angezeigt werden kann
	//Der Text kann durchaus schon Tags enthalten, jedoch werden z.B. chr(13) durch "<br>" ersetzt
	//$winId: JS-Winid (für die internen Links)
	//$helpFn: Dateiname der Hilfedatei (ohne Pfad und ohne Suffix), z.B. "1000-75" 
	//Links haben folgendes Format: "...<link>BEZEICHNUNG***DATEINAME</link>..."
	//Bedeutung: Angezeigt wird BEZEICHNUNG, verlinkt wird admin/help/DATEINAME.htm
	//LBS-Liste anzeigen: <lbs-list>
	//$newWin (optional): true=Hilfe wird per admin/help.php in einem unabhängigen Browserfenster angezeigt, d.h. Links werden entsprechend modifiziert
	//return: Hilfetext, oder false
	
	if (file_exists(MAIN_PATH.'/www/admin/help/'.$helpFn.'.htm')) {
		$help=file_get_contents(MAIN_PATH.'/www/admin/help/'.$helpFn.'.htm');
		
		//Menü-Kategorien
		if (preg_match_all("'<menucat>(.*?)</menucat>'s",$help,$link)>0) {
			for ($t=0;$t<count($link[0]);$t++) {
				$n=explode('***',$link[1][$t]);
				$l="<span class='menuCatHelp'><b>".$n[0]."</b></span>";
				$help=str_replace($link[0][$t],$l,$help);
			}
		}
		//Menü-Links
		if (preg_match_all("'<menulink>(.*?)</menulink>'s",$help,$link)>0) {
			for ($t=0;$t<count($link[0]);$t++) {
				$n=explode('***',$link[1][$t]);
				if ($newWin) {
					$l="<span class='menuLinkHelp' onClick='window.location=\"help.php?file=".$n[1]."\"'>".$n[0]."</span>";
				} else {
					$l="<span class='menuLinkHelp' onClick='ajax(\"showHelp\",\"9999\",\"".$winId."\",\"".$n[1]."\",\"\");'>".$n[0]."</span>";
				}
				$help=str_replace($link[0][$t],$l,$help);
			}
		}

		//Pfad (Link)
		if (preg_match_all("'<path>(.*?)</path>'s",$help,$link)>0) {
			for ($t=0;$t<count($link[0]);$t++) {
				$n=explode('***',$link[1][$t]);
				if ($newWin) {
					$l="<span class='linkHelp' onClick='window.location=\"help.php?file=".$n[1]."\"'>".$n[0]."</span> / ";
				} else {
					$l="<span class='linkHelp' onClick='ajax(\"showHelp\",\"9999\",\"".$winId."\",\"".$n[1]."\",\"\");'>".$n[0]."</span> / ";
				}
				$help=str_replace($link[0][$t],"<span style='font-weight:normal;'>".$l."</span>",$help);
			}
		}

		//Links
		if (preg_match_all("'<link>(.*?)</link>'s",$help,$link)>0) {
			for ($t=0;$t<count($link[0]);$t++) {
				$n=explode('***',$link[1][$t]);
				if ($newWin) {
					$l="<span class='linkHelp' onClick='window.location=\"help.php?file=".$n[1]."\"'>".$n[0]."</span>&nbsp;<span class='linkHelp' onClick='window.open(\"help.php?file=".$n[1]."\",\"_blank\");'>&#x21D7;</span>";
				} else {
					$l="<span class='linkHelp' onClick='ajax(\"showHelp\",\"9999\",\"".$winId."\",\"".$n[1]."\",\"\");'>".$n[0]."</span>&nbsp;<span class='linkHelp' onClick='window.open(\"help.php?file=".$n[1]."\",\"_blank\");'>&#x21D7;</span>";
				}
				$help=str_replace($link[0][$t],$l,$help);
			}
		}

		//LBS-Titel (wird vom LBS-Compiler erstellt)
		if (preg_match("'<lbs-titel>(.*?)</lbs-titel>'s",$help,$tmp)>0) {
			$l="<h1>".$tmp[1]."</h1>";
			$help=str_replace($tmp[0],$l,$help);
		}

		//LBS-Liste 
		if (preg_match_all("'<lbs-list>'s",$help,$tmp)>0) {
			$n="";
			$folderId=0;
			$ss1=sql_call("SELECT id,name,folderid FROM edomiProject.editLogicElementDef ORDER BY id ASC");
			while ($lbs=sql_result($ss1)) {
				
				$lbs['folderid']=dbRoot_getRootId($lbs['folderid']);	//ggf. Userfolder auf den entsprechenden Rootfolder mappen

				if ($folderId!=$lbs['folderid']) {
					if ($lbs['folderid']==12) {
						$tmp='Basis-Logikbausteine (12)';
					} else {
						$tmp=sql_getValue('edomiProject.editRoot','name',"id='".$lbs['folderid']."'");
					}
					$folderId=$lbs['folderid'];
					if (isEmpty($n)) {$n="<ul>";} else {$n.='</ul></li><br>';}
					$n.='<li><span style="color:#00a000;"><b>'.$tmp.'</b></span><ul>';
				}

				if ($newWin) {
					$n.="<li><span class='linkHelp' onClick='window.location=\"help.php?file=lbs_".$lbs['id']."\"'>".$lbs['name']." <span class=\"id\">".$lbs['id']."</span></span>&nbsp;<span class='linkHelp' onClick='window.open(\"help.php?file=lbs_".$lbs['id']."\",\"_blank\");'>&#x21D7;</span></li>";
				} else {
					$n.="<li><span class='linkHelp' onClick='ajax(\"showHelp\",\"9999\",\"".$winId."\",\"lbs_".$lbs['id']."\",\"\");'>".$lbs['name']." <span class=\"id\">".$lbs['id']."</span></span>&nbsp;<span class='linkHelp' onClick='window.open(\"help.php?file=lbs_".$lbs['id']."\",\"_blank\");'>&#x21D7;</span></li>";
				}
			}
			if (!isEmpty($n)) {$n.="</ul></li></ul>";}
			$help=str_replace('<lbs-list>',$n,$help);
		}

		//"TAB"-Tag ersetzen
		$help=str_replace('<->','&nbsp;&nbsp;&nbsp;&nbsp;',$help);

		//PHP-Tags ersetzen
		$help=str_replace('<?','&lt;?',$help);
		$help=str_replace('?>','?&gt;',$help);

		//MAINPATH-Tag ersetzen
		$help=str_replace('<MAIN_PATH>',MAIN_PATH,$help);
		//BACKUPPATH-Tag ersetzen
		$help=str_replace('<BACKUP_PATH>',BACKUP_PATH,$help);

		//Tags: unmittelbar folgende CR entfernen
		$help=str_replace("<li>\n",'<li>',$help);
		$help=str_replace("<ul>\n",'<ul>',$help);
		$help=str_replace("</li>\n",'</li>',$help);
		$help=str_replace("</ul>\n",'</ul>',$help);
		$help=str_replace("<table>\n",'<table>',$help);
		$help=str_replace("<tr>\n",'<tr>',$help);
		$help=str_replace("<td>\n",'<td>',$help);
		$help=str_replace("</table>\n",'</table>',$help);
		$help=str_replace("</tr>\n",'</tr>',$help);
		$help=str_replace("</td>\n",'</td>',$help);
		$help=str_replace("<pre>\n",'<pre>',$help);
		$help=str_replace("</pre>\n",'</pre>',$help);
		$help=str_replace("<pre>",'<pre style="color:#000080; font-family:EDOMIfontMono,Menlo,Courier,monospace; padding-left:10px; tab-size:4; white-space:pre-wrap; word-wrap:break-word;">',$help);	//Einrücken

		return $help;
	}
	return false;
}

function helpSearchRequest($search,$resultFn) {
	//einfache Suche über alle Hilfedateien (DB lohnt sich (noch) nicht)
	//$search: Suchausdruck
	//$resultFn: Dateiname der Ergebnisseite (ohne Suffix) - diese Datei wird erstellt!
	//return: Anzahl der Treffer 0..oo

	$search=strtoupper($search);
	$search=str_replace('ä','Ä',$search);
	$search=str_replace('ö','Ö',$search);
	$search=str_replace('ü','Ü',$search);

	$hits=Array();
	$n=glob(MAIN_PATH."/www/admin/help/*.htm");
	foreach ($n as $pathFn) {
		if (is_file($pathFn)) {
			$fn=basename($pathFn,'.htm');
			if ($fn!='result') {
				$help=file_get_contents($pathFn);
				if (strpos(strToUpper($help),$search)!==false) {
					if (preg_match("'<h1>(.*?)</h1>'",$help,$tmp)>0) {

					
						//PATH-Links entfernen
						if (preg_match_all("'<path>(.*?)</path>'s",$tmp[1],$link)>0) {
							for ($t=0;$t<count($link[0]);$t++) {
								$n=explode('***',$link[1][$t]);
								$l=$n[0]." / ";
								$tmp[1]=str_replace($link[0][$t],$l,$tmp[1]);
							}
						}
										
						if (strpos(strToUpper($tmp[1]),$search)!==false) {
							array_unshift($hits,'&gt; <link>'.$tmp[1].'***'.$fn.'</link> <span style="color:#909090;">'.$fn.'.htm</span>');
						} else {
							array_push($hits,'&gt; <link>'.$tmp[1].'***'.$fn.'</link> <span style="color:#909090;">'.$fn.'.htm</span>');
						}
					} else {
						if (preg_match("'<lbs-titel>(.*?)</lbs-titel>'",$help,$tmp)>0) {
							if (strpos(strToUpper($tmp[1]),$search)!==false) {
								array_unshift($hits,'&gt; Logikbaustein: <link>'.$tmp[1].'***'.$fn.'</link> <span style="color:#909090;">'.$fn.'.htm</span>');
							} else {
								array_push($hits,'&gt; Logikbaustein: <link>'.$tmp[1].'***'.$fn.'</link> <span style="color:#909090;">'.$fn.'.htm</span>');
							}
						}
					}
				}
				usleep(100);	
			}
		}
	}

	$f=fopen(MAIN_PATH.'/www/admin/help/'.$resultFn.'.htm','w');
	fwrite($f,'<h1>Suchergebnisse</h1><br>');
	if (count($hits)>0) {
		for ($t=0;$t<count($hits);$t++) {fwrite($f,$hits[$t].'<br>');}
	} else {
		fwrite($f,'keine Treffer gefunden');
	}
	fclose($f);
	
	return count($hits);
}
?>
