<?
/* 
 * EDOMI beta (Version 1.59) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
//Globale Includes
require("../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/admin/include/php/config.php");
require(MAIN_PATH."/www/admin/include/php/base.php");


sql_connect();

if (!$account=loginAdmin(httpGetVar('login'),httpGetVar('pass'))) {$account=array('','');}

?>
<!DOCTYPE HTML>
<html>
	<head>
		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="viewport" content="user-scalable=yes, width=1024">
		<meta name="apple-mobile-web-app-status-bar-style" content="black">
		<link rel="icon" href="img/admin_favicon.png?<?echo global_version;?>">
		<link rel="apple-touch-icon" href="img/admin_favicon.png?<?echo global_version;?>">
		<title>EDOMI &middot; Administration</title>
		<link rel="stylesheet" type="text/css" href="../shared/css/global.css?<?echo global_version;?>">
		<link rel="stylesheet" type="text/css" href="include/css/main.css?<?echo global_version;?>">
		<link rel="stylesheet" type="text/css" href="include/css/desktop.css?<?echo global_version;?>">
		<link rel="stylesheet" type="text/css" href="include/css/controls.css?<?echo global_version;?>">
		<link rel="stylesheet" type="text/css" href="include/css/app1_<?echo global_logicStyleTheme;?>.css?<?echo global_version;?>">
		<link rel="stylesheet" type="text/css" href="include/css/app2.css?<?echo global_version;?>">
		<link rel="stylesheet" type="text/css" href="include/css/app104.css?<?echo global_version;?>">
		<script type="text/javascript" src="../shared/js/main.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="../shared/js/camview.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="../shared/js/camview_global.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/main.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/controls.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/app1.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/app2.js?<?echo global_version;?>"></script>		
		<script type="text/javascript" src="include/js/app103.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/app104.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/app1000.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/app1003.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/app1020.js?<?echo global_version;?>"></script>
		<script type="text/javascript" src="include/js/app9999.js?<?echo global_version;?>"></script>
<?
//Visuelemente (JS) inkludieren
$n=glob(MAIN_PATH."/www/visu/include/js/preview*.js");
foreach ($n as $pathFn) {
	if (is_file($pathFn)) {
?>
		<script type="text/javascript" src="../visu/include/js/<?echo basename($pathFn);?>?<?echo global_version;?>"></script>
<?
	}
}
?>	
		<style id="cssPreview"></style>
		<style id="cssFonts"></style>
	</head>
<?
if (strpos(strtoupper($_SERVER['HTTP_USER_AGENT']),'WEBKIT')===false) {
?>
	<body style="font-family:<?echo global_adminFont;?>;">
		<div style="position:absolute; overflow:auto; top:0; left:0; bottom:0; right:0; display:inline; background:#343434;">
			<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0">
				<tr valign="middle" height="100%">
					<td align="center">
						<span style="font-size:20px; color:#fffff9;"><img src="../shared/img/edomi-white.png" width="96" height="32" valign="middle" style="margin:0;" draggable="false"><br><br>Webkit-Browser erforderlich</span><br><br>
						<span style="font-size:11px; color:#a9a9a0;">Die Administration kann nur mit einem Webkit-Browser<br>dargestellt werden, z.B. Apple/Safari oder Google/Chrome.</span>
					</td>
				</tr>
			</table>
		</div>
	</body>
<?
} else {
?>
	<body onLoad="firstinit('<?echo $account[0];?>','<?echo $account[1];?>','<?echo global_version;?>');" onContextMenu="return false;" style="font-family:<?echo global_adminFont;?>;">
		<div id="desktop" class="desktop">
			<table id="desktopTable" width="100%" height="100%" border="0" cellspacing="0" cellpadding="0" style="background:rgba(0,0,0,0.7); -webkit-transition:background 0.9s ease;">
				<tr valign="middle" height="60" style="font-size:10px; color:#595950;">
					<td align="center"><div id="desktopInfo" style="vertical-align:middle;"></div></td>
				</tr>
				<tr valign="middle">
					<td align="center">
						<div style="position:relative; width:516px; height:516px;">
<!-- Hauptmenü -->
							<div id="desktopMenu" style="display:none; position:absolute; left:0px; top:0px; width:516px; height:516px; border-radius:5px; overflow:hidden;">
								<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0">
									<tr valign="middle" height="181" style="background:rgba(0,0,0,0.03);">
										<td align="center">
											<div id="desktopProject" class="desktopButton" onClick="openWindow(103,'menu13');" onMouseover="desktopHoverParent(this,'rgba(100,200,0,0.25)');" onMouseout="desktopHoverParent(this,'');"></div>
										</td>
									</tr>
									<tr valign="middle" height="154">
										<td align="center">
											<div class="desktopIcon" onClick="openWindow(1);" style="position:absolute; left:0px; top:182px; text-align:left;">&nbsp;&nbsp;&nbsp;&nbsp;Logikeditor</div>
											<div class="desktopIcon" onClick="openWindow(1000,''+AJAX_SEPARATOR1+'10'+AJAX_SEPARATOR1+''+AJAX_SEPARATOR1+'typ=0');" style="position:absolute; left:0px; top:259px; text-align:left;">&nbsp;&nbsp;&nbsp;&nbsp;Konfiguration</div>
											<div class="desktopIcon" onClick="openWindow(2);" style="position:absolute; left:258px; top:182px; text-align:right;">Visueditor&nbsp;&nbsp;&nbsp;&nbsp;</div>
											<div class="desktopIcon" onClick="openWindow(103,'');" style="position:absolute; left:258px; top:259px; text-align:right;">Verwaltung&nbsp;&nbsp;&nbsp;&nbsp;</div>
										</td>
									</tr>
									<tr valign="middle" height="181" style="background:rgba(0,0,0,0.03);">
										<td align="center">
											<div class="desktopButton" onClick="openWindow(104);">Kameraaufnahmen</div>
											<br><br><br>
											<div onClick="openWindow(9999,'');" class="cmdHelp" style="float:initial;">?</div>
										</td>
									</tr>
								</table>
							</div>
<!-- Disc -->
							<div id="desktopDisc" class="desktopDisc" data-inited="0" data-locked="1" style="display:none;">
								<!-- Ajax-Content (für app0.php, wird ggf. komplett ausgeblendet) -->
								<div id="desktopContent" style="display:none;">
									<table width="516" height="516" border="0" cellspacing="0" cellpadding="0">
										<!-- Statusleiste (Top) -->
										<tr valign="top" height="50">
											<td align="center" style="background:#1f1f1a;">
												<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0" style="table-layout:auto;">
													<tr height="25">
														<td rowspan="2" width="183" align="left"><div id="desktopStatus2" style="padding-left:10px; color:#797970;"></div></td>
														<td width="150" align="center"><div id="desktopStatus1"></div></td>
														<td rowspan="2" width="183" align="right"><div id="desktopStatus3" style="padding-right:10px; color:#797970;"></div></td>
													</tr>
													<tr height="25">
														<td align="center">
															<table border="0" cellspacing="0" cellpadding="0" style="table-layout:auto;">
																<tr id="desktopControl">
																	<td align="center" id="desktopButtonRestart" class="desktopControlButton" onClick="ajax('restart','0','','','');" style="width:50px; border-left:1px solid #2f2f2a; border-right:1px solid #2f2f2a;"><img src="img/icon-4.png" style="padding-top:7px; width:auto; height:10px; margin:0; opacity:0.5;" draggable="false"></td>
																	<td align="center" id="desktopButtonStart" class="desktopControlButton" onClick="ajax('start','0','','','');" style="width:50px; border-right:1px solid #2f2f2a;"><img src="img/icon-3.png" style="padding-top:7px; width:auto; height:10px; margin:0; opacity:0.5;" draggable="false"></td>
																	<td align="center" id="desktopButtonPause" class="desktopControlButton" onClick="ajax('pause','0','','','');" style="width:50px; border-right:1px solid #2f2f2a;"><img src="img/icon-1.png" style="padding-top:7px; width:auto; height:10px; margin:0; opacity:0.5;" draggable="false"></td>
																</tr>
															</table>
														</td>
													</tr>
												</table>
											</td>
										</tr>

										<!-- Live-Projektname -->
										<tr valign="middle" height="118">
											<td align="center">
												<div id="desktopStatus0" style="padding:5px; max-width:250px; box-sizing:border-box; border:1px solid transparent; word-wrap:break-word;"></div>
											</td>
										</tr>

										<!-- Logo (Platzhalter) -->
										<tr valign="middle" height="180">
											<td align="center">&nbsp;</td>
										</tr>

										<!-- Meldungen -->
										<tr valign="middle" height="118">
											<td align="center">
												<div id="desktopStatus" style="font-size:10px;"></div>
											</td>
										</tr>

										<!-- Widget-Control -->
										<tr valign="top" height="50">
											<td align="center" style="background:#1f1f1a;">
												<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0" style="table-layout:auto;">
													<tr height="25">
														<td rowspan="2" width="50" align="left"><div onClick="desktopMoveWidget(-1);" style="display:block; width:50px; height:50px; color:#595950; text-align:center; line-height:50px; cursor:pointer;">&lt;</div></td>
														<td width="416" align="center"><div id="desktopWidgetsControlLink" style="display:block; width:300px; height:16px;"></div></td>
														<td rowspan="2" width="50" align="right"><div onClick="desktopMoveWidget(1);" style="display:block; width:50px; height:50px; color:#595950; text-align:center; line-height:50px; cursor:pointer;">&gt;</div></td>
													</tr>
												</table>
											</td>
										</tr>
									</table>
								</div>

								<!-- Widgets -->
								<div id="desktopWidgets" class="desktopWidgets"></div>

							</div>

<!-- EDOMI-Logo -->
							<div id="desktopLogo" onClick="desktopLogoClick();" class="desktopLogo">
								<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0">
									<tr valign="middle">
										<td align="center"><img src="../shared/img/edomi-white.png" width="96" height="32" valign="middle" style="margin:0;" draggable="false"></td>
									</tr>
								</table>
							</div>

						</div>
					</td>
				</tr>
				<tr valign="middle" height="60" style="font-size:10px; color:#595950;">
					<td align="center" width="500"><span onClick="self.location.reload();" style="cursor:pointer;">EDOMI <?echo global_version;?></span> &middot; <span onClick="openWindow(9999,'about');" style="cursor:pointer;">&copy; Dr. Christian Gärtner &gt; Spenden</span><?if (global_logStatistics) {echo '<iframe src="http://www.edomi.de/track.php?version='.global_version.'" style="width:1px; height:1px; display:none;"></iframe>';}?></td>
				</tr>
			</table>
		</div>

		<div id="windowContainer" class="appWindowContainer"></div>

		<div id="desktopHelp" class="desktopHelp">
			<div id="desktopHelpContent" class="desktopHelpContent"></div>
		</div>

		<div id="desktopNotesButton" onClick="openDesktopNotes();" class="desktopNotesButton">Notizen</div>
		
		<div id="desktopNotes" class="desktopNotes">
			<div id="desktopNotesContent" class="desktopNotesContent">
				<table width="100%" height="100%" border="0" cellspacing="3" cellpadding="0">
					<tr>
						<td><div style="position:relative; height:100%;"><textarea id="desktopNotesContent1" placeholder="Merkliste" data-type="1" wrap="off" class="desktopNotesInput" onkeydown="if (event.keyCode==9) {appAll_enableTabKey(this);}"></textarea></div></td>
						<td><div style="position:relative; height:100%;"><textarea id="desktopNotesContent2" placeholder="Projektnotizen" data-type="1" maxlength='10000' wrap="off" class="desktopNotesInput" onkeydown="if (event.keyCode==9) {appAll_enableTabKey(this);}"></textarea></div></td>
					</tr>
					<tr height="20">
						<td colspan="2" align="center">
							<div class="cmdButton" onClick="saveDesktopNotes();" style="margin-right:0;">Speichern & Schliessen</div>
						</td>
					</tr>
				</table>
				<div class="cmdHelp" onClick="deleteDesktopNotes(1);" style="position:absolute; right:50%; top:10px; margin-right:7px; background:#f08080;">X</div>
				<div class="cmdHelp" onClick="deleteDesktopNotes(2);" style="position:absolute; right:0px; top:10px; margin-right:10px; background:#f08080;">X</div>
				<div class="cmdHelp" onClick="openWindow(9999,'0-1-0');" style="position:absolute; right:0px; bottom:11px; margin-right:6px;">?</div>
			</div>
		</div>

		<div id="busy" class="busyContainer">
			<table width="100%" height="100%" border="0">
				<tr valign="middle"><td align="center"><div class="busyAnim"></div></td></tr>
			</table>
		</div>

	</body>
<?
}
?>
</html>
<?

sql_disconnect();

?>
