###[DEF]###
[name		=Restzeit-Timer			]

[e#1 TRIGGER=Trigger 			]
[e#2		=Dauer (s) #init=10		]

[a#1		=0|1					]
[a#2		=Restzeit				]

[v#1		=10						]
[v#2		=0						]
###[/DEF]###


###[HELP]###
Dieser Baustein bildet einen (retriggerbaren) Timer mit Restzeitanzeige nach.

Ein Telegramm &ne;0 an E1 startet den Baustein, bzw. startet den Baustein neu:
Ein Timer beginnt abzulaufen und wird durch jedes weitere Telegramm &ne;0 an E1 neu gestartet.
Ausgang A1 wird bei JEDEM Telegramm &ne;0 an E1 auf 1 gesetzt.
An Ausgang A2 wird sekündlich die verbleibende Restzeit (s) ausgegeben.
Läuft der Timer vollständig ab, wird A2 (Restzeit!) auf 0 gesetzt. A1 wird ebenfalls auf 0 gesetzt.

Anwendungsbeispiel:
BWM-Signal verlängern und Restzeit visualisieren:
An A2 (Restzeit) muss ein KO gesetzt werden - dieses KO kann dann z.B. in der Visu angezeigt werden oder ein dynamisches Design abrufen.

E1: &ne;0 = Trigger. Sobald ein neues Telegramm &ne;0 eintrifft, wird der Timer wieder neu gestartet (retriggern).
E2: Zeit in Sekunden
A1: Bei jedem(!) Telegramm &ne;0 an E1 wird A1 auf 1 gesetzt. Nach Ablauf der Zeit wird A1 auf 0 gesetzt.
A2: Hier wird sekündlich die verbleibende Restzeit in Sekunden ausgegeben. Nach Ablauf des Timer liegt hier eine 0 an.
###[/HELP]###


###[LBS]###
<?
function LB_LBSID($id) {
	if (($E=logic_getInputs($id)) && ($V=logic_getVars($id))) {

		if (logic_getState($id)==0) {

			if ($E[1]['value']!=0 && $E[1]['refresh']==1) {
				logic_setVar($id,1,(getMicrotime()+$E[2]['value']));
				logic_setVar($id,2,getMicrotime());		//Zeitpunkt der letzten Restzeitausgabe merken
				logic_setOutput($id,1,1); 				//Neustart: A1=1
				logic_setOutput($id,2,$E[2]['value']); 	//Neustart: A2=Restzeit
				logic_setState($id,1,1000,true);		//1-Sekunden-Takt als kleinsten gemeinsamen Nenner (Timer und Restzeit)
			}

		} else {

			//Retriggern
			if ($E[1]['value']!=0 && $E[1]['refresh']==1) {
			
				logic_setVar($id,1,(getMicrotime()+$E[2]['value']));
				logic_setVar($id,2,getMicrotime());	//Zeitpunkt der letzten Restzeitausgabe merken
				logic_setOutput($id,1,1); 				//A1=1
				logic_setOutput($id,2,$E[2]['value']); 	//A2=Restzeit

			} else {

				if (getMicrotime()>=$V[1]) { //Zeit abgelaufen?
				
					logic_setOutput($id,1,0); 			//A1=0
					logic_setOutput($id,2,0);			//A2=0 (keine Restzeit mehr vorhanden)
					logic_setState($id,0);

				} else {	//Restzeit im Sekundentakt ausgeben
				
					$tmp=getMicrotime();
					if (($tmp-$V[2])>=1) {
						logic_setVar($id,2,getMicrotime());				//Zeitpunkt der letzten Restzeitausgabe merken
						logic_setOutput($id,2,intval($V[1]-$tmp)); 			//A2=Restzeit
					}
					
				}

			}
			
		}

	}

}
?>
###[/LBS]###


###[EXEC]###
<?

?>
###[/EXEC]###
