<?
/* 
 * EDOMI beta (Version 1.59) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
======================================================================================================================================================
ADMIN/VISU/MAIN: Kamera-Zugriff
======================================================================================================================================================
*/

function getLiveCamImgPreview($camUrl,$camTyp) {
	//Preview für Adminseite (Kameraeinstellungen)
	//$camUrl: URL
	//$camTyp: 0=JPG, 1=MJPEG
	//return: false, oder Bild-Dateiname (ohne Pfad)

	if (!isEmpty($camUrl)) {
		//Bild grabben
		if ($camTyp==0) {$img=getLiveCamImgFromSnapshot($camUrl);} else {$img=getLiveCamImgFromStream($camUrl);}
		if ($img) {
			$f=fopen(MAIN_PATH.'/www/data/tmp/campreview.jpg','w');
			fwrite($f,$img);
			fclose($f);

			if (file_exists(MAIN_PATH.'/www/data/tmp/campreview.jpg')) {
				return 'campreview.jpg';
			}
		}
	}
	return false;
}

function getLiveCamImg($camId,$returnTyp,$url=null,$urlTyp=null) {
	//Liefert entweder ein echtes Livebild oder ein Bild aus dem Cache (je nach Einstellung: global_camLiveMaxRefresh)
	//$camId: db.cam.id
	//$returnTyp: 0=String mit JPG-Daten, 1=Dateiname (URL) der gespeicherten JPG-Daten
	//$url/$urlTyp: Kameraeigenschaften, leer/null=aus DB holen
	//return: JPG-Datenstring, Dateiname (URL), oder false

	if ($camId>0) {
		if (isEmpty($url)) {
			$n=sql_getValues('edomiLive.cam ','id,url,mjpeg','id='.$camId);
			if ($n!==false) {
				$url=$n['url'];
				$urlTyp=$n['mjpeg'];
			}
		}

		if (!isEmpty($url)) {
			
			if (global_camLiveMaxRefresh>0) {

				//Cache aktiviert => ggf. zwischenspeichern

				$ts=getMicrotimeInt();
				$tmp=sql_getValue('edomiLive.cam','cachets','id='.$camId);
				if (isEmpty($tmp) || ($tmp+(global_camLiveMaxRefresh*10000))<$ts) {
	
					//Timestamp in DB aktualisiern (VOR dem eigentlichen Grabben, damit bei mehreren Instanzen möglichst nicht mehrmals gegrabbt wird)
					sql_call("UPDATE edomiLive.cam SET cachets=".$ts." WHERE id=".$camId);
		
					if ($urlTyp==0) {$img=getLiveCamImgFromSnapshot($url);} else {$img=getLiveCamImgFromStream($url);}
					if ($img) {
						$f=fopen(MAIN_PATH.'/www/data/tmp/livecam-'.$camId.'-'.$ts.'.jpg','w');
						fwrite($f,$img);
						fclose($f);
						rename(MAIN_PATH.'/www/data/tmp/livecam-'.$camId.'-'.$ts.'.jpg',MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg');
	
						if ($returnTyp==0) {
							return $img;
						} else if (file_exists(MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg')) {
							return 'cam'.$camId.'.jpg';
						}
					}
				} else if (file_exists(MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg')) {
					if ($returnTyp==0) {
						return file_get_contents(MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg');
					} else {
						return 'cam'.$camId.'.jpg';
					}
				}

			} else {

				//kein Cache aktiviert => immer grabben

				if ($urlTyp==0) {$img=getLiveCamImgFromSnapshot($url);} else {$img=getLiveCamImgFromStream($url);}
				if ($img) {
					if ($returnTyp==0) {
						return $img;
					} else {
						$ts=getMicrotimeInt();
						$f=fopen(MAIN_PATH.'/www/data/tmp/livecam-'.$camId.'-'.$ts.'.jpg','w');
						fwrite($f,$img);
						fclose($f);
						rename(MAIN_PATH.'/www/data/tmp/livecam-'.$camId.'-'.$ts.'.jpg',MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg');
						if (file_exists(MAIN_PATH.'/www/data/liveproject/cam/live/cam'.$camId.'.jpg')) {return 'cam'.$camId.'.jpg';}
					}
				}

			}
		}
	}
	return false;
}

function getLiveCamImgFromSnapshot($url) {
	//$url: URL des Snapshots (JPG):
	//	- reine URL, z.B. http://login:pass@1.2.3.4/...
	//	- oder mittels cUrl, z.B. CURL***ANY|BASIC|DIGEST***login***pass***http://1.2.3.4/snapshot.jpg
	//return: die reinen JPG-Daten, oder false

	$tmp=explode('***',$url,5);
	if (strtoupper(trim($tmp[0]))=='CURL') {

		if (strtoupper(trim($tmp[1]))=='ANY') 			{$auth=CURLAUTH_ANY;}
		else if (strtoupper(trim($tmp[1]))=='BASIC') 	{$auth=CURLAUTH_BASIC;}
		else if (strtoupper(trim($tmp[1]))=='DIGEST') 	{$auth=CURLAUTH_DIGEST;}

		$curl=curl_init();
		curl_setopt($curl,CURLOPT_URL,trim($tmp[4]));
		curl_setopt($curl,CURLOPT_RETURNTRANSFER,true);
		curl_setopt($curl,CURLOPT_USERPWD,trim($tmp[2]).':'.trim($tmp[3]));		
		curl_setopt($curl,CURLOPT_HTTPAUTH,$auth);
		$r=curl_exec($curl);
		curl_close($curl);
		return $r;

	} else {
		$ctx=stream_context_create(array('http' => array('timeout' => 10 )));	//10 Sekunden Timeout
		return file_get_contents($url,0,$ctx,0,10*1024*1024);					//max. 10 MB, dann Abbruch (falls man versehentlich einen MJPEG-Stream ausgewählt hat bei Preview)
	}
}

function getLiveCamImgFromStream($url) {
	//$url: URL des MJPEG-Streams (HTTP)
	//return: die reinen JPG-Daten, oder false

	$timeout=10;	//nach 10 Sekunden abbrechen (Verbindungsaufbau NICHT mit eingerechnet)

	$img=false;
	$frameBoundary=false;

	//Boundary-Zeichenkette im Header suchen
	$n=get_headers($url);
	if ($n!==false) {
		for ($t=0;$t<count($n);$t++) {
			if (preg_match('/boundary=(.*)/i',$n[$t],$m)) {
				$frameBoundary=trim($m[1]);
				break;
			}
		}
	}

	//MJPEG-Stream: das erste vollständige JPG extrahieren
	if ($frameBoundary!==false) {
		$data='';

		$ctx=stream_context_create(array('http'=>array('timeout' => 10)));	//10 Sekunden Timeout
		$f=fopen($url,'r',false,$ctx);
		if ($f) {

			$t1=microtime(true);
			
			//erstes Boundary abwarten
			do {
				$n=fgets($f);
			} while (strpos($n,$frameBoundary)===false && ((microtime(true)-$t1)<$timeout));

			//bis zum nächsten Boundary mitlesen
			if (strpos($n,$frameBoundary)!==false) { //Timeout?
				do {
					$n=fgets($f);
					if (strpos($n,$frameBoundary)===false) {$data.=$n;}
				} while (strpos($n,$frameBoundary)===false && ((microtime(true)-$t1)<$timeout));
		
				//JPG-Daten suchen und ausschneiden
				if (strpos($n,$frameBoundary)!==false) { //Timeout?

					$x=strpos($data,"\r\n\r\n");
					if ($x===false) {$x=strpos($data,"\n\n");}
					if ($x===false) {$x=strpos($data,"\r\r");}
					if ($x===false) {
						$x=strpos($data,chr(0xff).chr(0xd8));
						if ($x!==false) {$img=substr($data,$x);}
					} else {
						$img=substr($data,$x+4);
					}

				}
			}
			
			fclose($f);
		}
	}

	return $img;
}

?>
