<?
/* 
 * EDOMI beta (Version 1.59) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
-----------------------------------------------------------------------------------------------------------------------------------------
Controltyp 20 - Kamera (Livebild und Archiv)
-----------------------------------------------------------------------------------------------------------------------------------------
*/
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");
require(MAIN_PATH."/www/shared/php/incl_camera.php");

//Eigene Includes
require(MAIN_PATH."/www/visu/include/php/config.php");
require(MAIN_PATH."/www/visu/include/php/base.php");


sql_connect();

if (checkVisuSid($visuId,$sid)) {cmd($cmd);}

function cmd($cmd) {
	global $appId,$visuId,$pageId,$data,$dataArr,$phpdata,$phpdataArr,$sid;
	global $global_weekdays;

	if ($cmd=='camLiveStream') {
		//direktes MJPEG-Streaming
		
		$camid=sql_getValue('edomiLive.camView','camid','id='.$dataArr[1]);
		if (!isEmpty($camid)) {
			$url=sql_getValue('edomiLive.cam','url','id='.$camid.' AND mjpeg=1');
			if (!isEmpty($url)) {
?>
				control20_callbackLiveStream(<?echo $dataArr[0];?>,"<?ajaxValue($url);?>");
<?
				return;
			}
		}
		//Fehler			
?>
		control20_callbackLiveStream(<?echo $dataArr[0];?>,"");
<?
	}
	
	if ($cmd=='camLive') {
		//Einzelbild

		$camView=sql_getValues('edomiLive.camView','*','id='.$dataArr[1]);
		if ($camView!==false) {
			$imgUrl=getLiveCamImg($camView['camid'],1);
			if ($imgUrl) {
				if ($camView['srctyp']==0) {
?>
					if (document.getElementById("e-<?echo $dataArr[0];?>-imglive")) {
						var camView=new class_camView();					
						camView.setProperty("url","../data/liveproject/cam/live/<?echo $imgUrl;?>?ts=<?echo getTimestampId();?>");		
						camView.setProperty("dstcanvas",document.getElementById("e-<?echo $dataArr[0];?>-imglive"));		
						camView.setProperty("render",true);
						camView.setProperty("callback","control20_callbackLiveFrame(\"<?echo $dataArr[0];?>\",true)");
						camView.setProperty("callbackerror","control20_callbackLiveFrame(\"<?echo $dataArr[0];?>\",false)");						
						camView.loadImageToDst();
					}
<?
				} else {
?>
					if (document.getElementById("e-<?echo $dataArr[0];?>-imglive")) {
						var camView=new class_camView();					
						camView.setProperty("url","../data/liveproject/cam/live/<?echo $imgUrl;?>?ts=<?echo getTimestampId();?>");		
						camView.setProperty("dstcanvas",document.getElementById("e-<?echo $dataArr[0];?>-imglive"));		
						camView.setProperty("render",true);
						camView.setProperty("callback","control20_callbackLiveFrame(\"<?echo $dataArr[0];?>\",true)");
						camView.setProperty("callbackerror","control20_callbackLiveFrame(\"<?echo $dataArr[0];?>\",false)");
						
						camView.setProperty("srctyp",parseInt("<?echo $camView['srctyp'];?>"));		
						camView.setProperty("db_zoom",parseInt("<?echo $camView['zoom'];?>"));
						camView.setProperty("db_a1",parseInt("<?echo (($camView['srctyp']==1)?0:$camView['a1']);?>"));
						camView.setProperty("db_a2",parseInt("<?echo $camView['a2'];?>"));
						camView.setProperty("db_x",parseInt("<?echo $camView['x'];?>"));
						camView.setProperty("db_y",parseInt("<?echo $camView['y'];?>"));
						camView.setProperty("db_dstw",parseInt(document.getElementById("e-<?echo $dataArr[0];?>-imglive").offsetWidth));		
						camView.setProperty("db_dsth",parseInt(document.getElementById("e-<?echo $dataArr[0];?>-imglive").offsetHeight));		
						camView.setProperty("db_srcr",parseInt("<?echo (($camView['srctyp']==1)?0:$camView['srcr']);?>"));
						camView.setProperty("db_srcd",parseInt("<?echo (($camView['srctyp']==1)?0:$camView['srcd']);?>"));
						camView.setProperty("db_srcs",parseInt("<?echo $camView['srcs'];?>"));
						camView.init();
					}
<?
				}
				return;
			}
		}
		//Fehler
?>
		control20_callbackLiveFrame("<?echo $dataArr[0];?>",false);
<?
	}

	if ($cmd=='camArchiv') {
		$archivName=sql_getValue('edomiLive.archivCam','name','id='.$dataArr[4]);
		if (isEmpty($archivName)) {$archivName='???';}

		//mode=1: vor, =-1: zurück, 0=aktuellster Eintrag
		if ($dataArr[1]==0) { //aktuellsten Eintrag (dies ist Default beim Öffnen)
			$n=sql_getValues('edomiLive.archivCamData','*',"(targetid=".$dataArr[4].") ORDER BY datetime DESC,ms DESC LIMIT 0,1");
		}
		if ($dataArr[1]==1) { //Navigation: Älteres Bild
			$n=sql_getValues('edomiLive.archivCamData','*',"(targetid=".$dataArr[4]." AND CONCAT(datetime,LPAD(ms,6,'0'))<'".$dataArr[2]."') ORDER BY datetime DESC,ms DESC LIMIT 0,1");
		}
		if ($dataArr[1]==-1) { //Navigation: Jüngeres Bild
			$n=sql_getValues('edomiLive.archivCamData','*',"(targetid=".$dataArr[4]." AND CONCAT(datetime,LPAD(ms,6,'0'))>'".$dataArr[2]."') ORDER BY datetime ASC,ms ASC LIMIT 0,1");
		}

		if ($n!==false) {
			$fn=getArchivCamFilename($n['targetid'],$n['camid'],$n['datetime'],$n['ms']).'.jpg';

			if ($dataArr[5]==0) {$tmp=sql_getDateTime($n['datetime']);}
			else if ($dataArr[5]==1) {$tmp=sql_getDateTime($n['datetime'])."<span style='opacity:0.75;'>.".sprintf("%06d",$n['ms'])."</span>";}
			else if ($dataArr[5]==2) {$tmp=$global_weekdays[date('N',strtotime($n['datetime']))-1]." / ".sql_getDateTime($n['datetime']);}
			else if ($dataArr[5]==3) {$tmp=$global_weekdays[date('N',strtotime($n['datetime']))-1]." / ".sql_getDateTime($n['datetime'])."<span style='opacity:0.75;'>.".sprintf("%06d",$n['ms'])."</span>";}

			if (isEmpty($dataArr[6])) {$dataArr[6]=0;}
			$camView=sql_getValues('edomiLive.camView','*','id='.$dataArr[6]);
			if ($camView!==false) {
				$imgUrl=getLiveCamImg($camView['camid'],1);
				if ($imgUrl) {
					if ($camView['srctyp']==0) {
?>
						if (document.getElementById("e-<?echo $dataArr[0];?>-imglive")) {
							var camView=new class_camView();					
							camView.setProperty("url","../data/liveproject/cam/archiv/<?echo $fn;?>?ts=<?echo getTimestampId();?>");		
							camView.setProperty("dstcanvas",document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv"));		
							camView.setProperty("render",true);
							camView.setProperty("callback","control20_callbackArchivLoaded(<?echo $dataArr[0];?>,\"<?echo ajaxValueHTML(str_replace(chr(34),'\"',$archivName));?><br><?echo $tmp;?>\",\"<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>\",true)");
							camView.setProperty("callbackerror","control20_callbackArchivLoaded(<?echo $dataArr[0];?>,\"<?echo ajaxValueHTML(str_replace(chr(34),'\"',$archivName));?><br><?echo $tmp;?>\",\"<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>\",false)");						
							camView.loadImageToDst();
						}
<?
					} else {
?>
						if (document.getElementById("e-<?echo $dataArr[0];?>-imglive")) {
							var camView=new class_camView();					
							camView.setProperty("url","../data/liveproject/cam/archiv/<?echo $fn;?>?ts=<?echo getTimestampId();?>");		
							camView.setProperty("dstcanvas",document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv"));		
							camView.setProperty("render",true);
							camView.setProperty("callback","control20_callbackArchivLoaded(<?echo $dataArr[0];?>,\"<?echo ajaxValueHTML(str_replace(chr(34),'\"',$archivName));?><br><?echo $tmp;?>\",\"<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>\",true)");
							camView.setProperty("callbackerror","control20_callbackArchivLoaded(<?echo $dataArr[0];?>,\"<?echo ajaxValueHTML(str_replace(chr(34),'\"',$archivName));?><br><?echo $tmp;?>\",\"<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>\",false)");						
						
							camView.setProperty("srctyp",parseInt("<?echo $camView['srctyp'];?>"));		
							camView.setProperty("db_zoom",parseInt("<?echo $camView['zoom'];?>"));
							camView.setProperty("db_a1",parseInt("<?echo (($camView['srctyp']==1)?0:$camView['a1']);?>"));
							camView.setProperty("db_a2",parseInt("<?echo $camView['a2'];?>"));
							camView.setProperty("db_x",parseInt("<?echo $camView['x'];?>"));
							camView.setProperty("db_y",parseInt("<?echo $camView['y'];?>"));
							camView.setProperty("db_dstw",parseInt(document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv").offsetWidth));		
							camView.setProperty("db_dsth",parseInt(document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv").offsetHeight));	
							camView.setProperty("db_srcr",parseInt("<?echo (($camView['srctyp']==1)?0:$camView['srcr']);?>"));
							camView.setProperty("db_srcd",parseInt("<?echo (($camView['srctyp']==1)?0:$camView['srcd']);?>"));
							camView.setProperty("db_srcs",parseInt("<?echo $camView['srcs'];?>"));
							camView.init();
						}						
<?
					}
				}
			} else {
				//kein camView definiert => Rohbild anzeigen
?>
				if (document.getElementById("e-<?echo $dataArr[0];?>-imglive")) {
					var camView=new class_camView();					
					camView.setProperty("url","../data/liveproject/cam/archiv/<?echo $fn;?>?ts=<?echo getTimestampId();?>");		
					camView.setProperty("dstcanvas",document.getElementById("e-<?echo $dataArr[0];?>-imgarchiv"));		
					camView.setProperty("render",true);
					camView.setProperty("callback","control20_callbackArchivLoaded(<?echo $dataArr[0];?>,\"<?echo ajaxValueHTML(str_replace(chr(34),'\"',$archivName));?><br><?echo $tmp;?>\",\"<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>\",true)");
					camView.setProperty("callbackerror","control20_callbackArchivLoaded(<?echo $dataArr[0];?>,\"<?echo ajaxValueHTML(str_replace(chr(34),'\"',$archivName));?><br><?echo $tmp;?>\",\"<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>\",false)");						
					camView.loadImageToDst();
				}
<?
			}
		} else {
			if (sql_getCount('edomiLive.archivCamData',"targetid=".$dataArr[4])==0) {
				//Archiv ist leer
?>
				control20_callbackArchivLoaded(<?echo $dataArr[0];?>,"<?echo ajaxValueHTML($archivName);?>","",false);
<?
			} else {
				//Cursor ist an einem Anschlag (Anfang oder Ende)
?>
				control20_callbackArchivLoaded(<?echo $dataArr[0];?>,"","",false);
<?
			}
		}
	}
}

sql_disconnect();
?>
