<?
/* 
 * EDOMI beta (Version 1.59) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
-----------------------------------------------------------------------------------------------------------------------------------------
Controltyp 21 - Diagramm
-----------------------------------------------------------------------------------------------------------------------------------------
*/
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/visu/include/php/config.php");
require(MAIN_PATH."/www/visu/include/php/base.php");
require(MAIN_PATH."/main/include/php/incl_ga.php");		//nur für parseGAValues()


sql_connect();

if (checkVisuSid($visuId,$sid)) {cmd($cmd);}

function cmd($cmd) {
	global $appId,$visuId,$pageId,$data,$dataArr,$phpdata,$phpdataArr,$sid;

	if ($cmd=='chartDraw') {
		$cChart=new class_chart();

		$cChart->objId=$dataArr[0];
		$cChart->chartId=$dataArr[1];
		$cChart->chartWidth=$dataArr[2];
		$cChart->chartHeight=$dataArr[3];
		$cChart->chartFontsize=$dataArr[4];
		$cChart->chartDateFromTo=$dataArr[5];
		$cChart->koValue=$dataArr[6];
		$cChart->chartParaTitle=$dataArr[7];
		$cChart->chartParaXaxis=$dataArr[8];

		$cChart->drawChart();
		$cChart=null;

		//Refresh-Timer setzen
?>
		control21_callbackSetTimer("<?echo $dataArr[0];?>","<?ajaxEcho($dataArr[5]);?>","<?ajaxEcho($dataArr[6]);?>");
<?
	}
}

sql_disconnect();



class class_chart {

	public $objId=null;
	public $chartId=0;
	public $chartWidth=0;
	public $chartHeight=0;
	public $chartFontsize=0;
	public $chartDateFromTo=null;
	public $koValue=null;
	public $chartParaTitle=0;
	public $chartParaXaxis=0;
	
	private $chartMeta=0;
	private $chartInt1=null;
	private $chartInt2=null;
	private $chartMarginX=0;
	private $chartMarginY=0;
	private $visibleYaxis=0;


	public function drawChart() {		
		//Parameter
		$ss1=sql_call("SELECT * FROM edomiLive.chart WHERE (id=".$this->chartId.")");
		if ($this->chartMeta=sql_result($ss1)) {

			$chartDateFrom=parseGAValues($this->chartMeta['datefrom']);
			$chartDateTo=parseGAValues($this->chartMeta['dateto']);
			
			//Rand (links und rechts) zur Zeichenfläche hin
			$this->chartMarginX=intVal(1*$this->chartFontsize);

			//Rand (oben und unten) zur Zeichenfläche hin
			if ($this->chartParaTitle==0 && $this->chartParaXaxis==0) {
				$this->chartMarginY=intVal($this->chartFontsize/2); 	//Sonderfall: Titelzeile und X-Achsenbeschriftung deaktiviert
			} else {
				$this->chartMarginY=intVal(3*$this->chartFontsize); 	//Normalfall
			}
	
			//Intervall aus Design (bzw. dynamischen Design) holen
			$tmp=explode('**',$this->chartDateFromTo);
			if (count($tmp)==2) {
				$tmpFrom=trim(parseGAValues($tmp[0]));
				$tmpTo=trim(parseGAValues($tmp[1]));
				if (!isEmpty($tmpFrom)) {$chartDateFrom=$tmpFrom;}
				if (!isEmpty($tmpTo)) {$chartDateTo=$tmpTo;}
			}
			
?>
			var cWidth=<?echo $this->chartWidth;?>;
			var cHeight=<?echo $this->chartHeight;?>;
			var obj=document.getElementById("e-<?echo $this->objId;?>");
			var canvas=document.getElementById("e-<?echo $this->objId;?>-canvas");
			var c=canvasScale(canvas,cWidth,cHeight);
			if (c!==false) {
				c.font=obj.style.fontSize+" "+obj.style.fontFamily;
				var fontArgs=c.font.split(' ',1);
				var fontNewSize=obj.style.fontSize;
				c.font=fontNewSize+' '+fontArgs[fontArgs.length-1];
				var fontArgs=c.font.split(' ',1);
				var textHeight=parseInt(fontArgs[0].replace("px",""));
	
				var yAxisMaxWidth=0;
	
				c.fillStyle=obj.style.backgroundColor;
				c.clearRect(0,0,cWidth,cHeight);
<?
	
			//Zeitbereich berechnen:
			//KO-Archive durchgehen und jeweils Min/Max-Datetime heraussuchen
			$chartCount=0;
			$ss1=sql_call("SELECT archivkoid FROM edomiLive.chartList WHERE (targetid=".$this->chartId.")");
			while ($n=sql_result($ss1)) {
				$ss2=sql_call("SELECT MIN(datetime) AS anz1,MAX(datetime) AS anz2,targetid FROM edomiLive.archivKoData WHERE (targetid=".$n['archivkoid'].")");
				if ($nn=sql_result($ss2)) {
					if ($nn['targetid']>0) { //Existieren überhaupt Daten?
						if (isEmpty($this->chartInt1) || strtotime($nn['anz1'])<strtotime($this->chartInt1)) {$this->chartInt1=$nn['anz1'];}
						if (isEmpty($this->chartInt2) || strtotime($nn['anz2'])>strtotime($this->chartInt2)) {$this->chartInt2=$nn['anz2'];}
						$chartCount++;
					}
				}
			}
			sql_close($ss1);
	
			if (!isEmpty($chartDateFrom)) {$this->chartInt1=date("Y-m-d H:i:s",strtotime($this->parseDate($chartDateFrom)));}
			if (!isEmpty($chartDateTo)) {$this->chartInt2=date("Y-m-d H:i:s",strtotime($this->parseDate($chartDateTo)));}
	
			if (strtotime($this->chartInt2)<strtotime($this->chartInt1)) {
				$tmp=$this->chartInt1;
				$this->chartInt1=$this->chartInt2;
				$this->chartInt2=$tmp;
			}


			//ggf. globales Min/Max über alle gewählten Graphen ermitteln
			if (isEmpty($this->chartMeta['ymin']) || isEmpty($this->chartMeta['ymax'])) {
				$yMin=null;
				$yMax=null;
				$ss1=sql_call("SELECT archivkoid FROM edomiLive.chartList WHERE (targetid=".$this->chartId." AND yscale=1)");
				while ($n=sql_result($ss1)) {
					$ss2=sql_call("SELECT MIN(CAST(gavalue AS DECIMAL(20,4))) AS anz1,MAX(CAST(gavalue AS DECIMAL(20,4))) AS anz2 FROM edomiLive.archivKoData WHERE (targetid=".$n['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."')");
					if ($nn=sql_result($ss2)) {
						if (is_numeric($nn['anz1']) && (isEmpty($yMin) || $nn['anz1']<$yMin)) {$yMin=$nn['anz1'];}
						if (is_numeric($nn['anz2']) && (isEmpty($yMax) || $nn['anz2']>$yMax)) {$yMax=$nn['anz2'];}
					}
					sql_close($ss2);
				}
				sql_close($ss1);
				if (isEmpty($this->chartMeta['ymin'])) {$this->chartMeta['ymin']=$yMin;}
				if (isEmpty($this->chartMeta['ymax'])) {$this->chartMeta['ymax']=$yMax;}
			}

	
			//Zeichnen:
			$this->diagDataAvailable=false;
			if ($chartCount>0) {
				$diagDataAvailable=$this->drawYaxis($chartCount);
				$this->drawXaxis($chartCount);
				$this->drawTitel($chartCount);
				$this->drawCharts($chartCount);
			}
	
	
			//Hinweis wenn keine Daten vorhanden sind:
			if (!$diagDataAvailable) {
?>
				c.globalAlpha=0.5;
				c.fillStyle=obj.style.backgroundColor;
				c.clearRect(0,0,cWidth,cHeight);
				c.fillStyle=obj.style.color;
				c.textAlign="center";
				c.textBaseline="middle";
				c.fillText("keine Daten vorhanden",cWidth/2,cHeight/2);
<?
			}
?>
			}
<?
		}
		sql_close($ss1);
	}

	private function drawYaxis($chartCount) {
?>
		var axis=new Array();
<?



		$chartNumber=0;
		$ss1=sql_call("SELECT * FROM edomiLive.chartList WHERE (targetid=".$this->chartId.") ORDER BY id DESC");
		while ($chart=sql_result($ss1)) {
	
			//Farbe holen
			$chart['s1']=sql_getValue('edomiLive.visuFGcol','color',"id='".$chart['s1']."'");
	
			//Min/Max/Anzahl der Werte
			$ss2=sql_call("SELECT COUNT(datetime) AS anz0,MIN(CAST(gavalue AS DECIMAL(20,4))) AS anz1,MAX(CAST(gavalue AS DECIMAL(20,4))) AS anz2 FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."')");
			if ($nn=sql_result($ss2)) {
				$yAnz=$nn['anz0'];
				$yMin=$nn['anz1'];
				$yMax=$nn['anz2'];
			}
			sql_close($ss2);

			//ggf. globale Y-Einstellungen verwenden
			if ($chart['yscale']==1 && !isEmpty($this->chartMeta['ymin']) && !isEmpty($this->chartMeta['ymax'])) {
				$chart['ymin']=$this->chartMeta['ymin'];
				$chart['ymax']=$this->chartMeta['ymax'];
				$chart['yticks']=$this->chartMeta['yticks'];
				$chart['ynice']=$this->chartMeta['ynice'];
			}

			//wenn ymin und/oder ymax gesetzt sind: die db-Werte nehmen (also ymin/ymax)
			if (!isEmpty($chart['ymin'])) {$yMin=$chart['ymin'];}
			if (!isEmpty($chart['ymax'])) {$yMax=$chart['ymax'];}
	
			if ($chart['yshow']==1 || $yAnz>0) { //gibt es überhaupt Daten für dieses Diagramm (oder erzwingt yshow=1 die Anzeige der Achse)?
				if (isEmpty($chart['yticks']) || $chart['yticks']==0) {
					$chart['yticks']=floor(($this->chartHeight-(2*$this->chartMarginY))/($this->chartFontsize*2));
				}
				$tmp=$this->getInterval($yMin,$yMax,$chart['yticks'],$chart['ynice']);
				if ($yAnz==0) {$tmp=array(0,1,1,1,1);}	//Fake-Intervall, falls keine Daten vorhanden sind aber yshow=1 ist
				if ($chart['ystyle']<2) {
					$currentValue='';
					if ($chart['yshowvalue']==1) {
						$ss2=sql_call("SELECT CAST(gavalue AS DECIMAL(20,4)) AS vavg FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid'].") ORDER BY datetime DESC,ms DESC LIMIT 0,1");
						if ($nn=sql_result($ss2)) {
							$currentValue=$nn['vavg'];
						}
						sql_close($ss2);
					}
?>				
					axis.push({interval:[<?echo $tmp[0];?>,<?echo $tmp[1];?>,<?echo $tmp[2];?>,<?echo $tmp[3];?>,<?echo $tmp[4];?>],ygrid:["<?echo $chart['ygrid1'];?>","<?echo $chart['ygrid2'];?>","<?echo $chart['ygrid3'];?>"],style:[pS("<?ajaxEcho($chart['s1']);?>","<?ajaxEcho($this->koValue);?>"),textHeight,"<?ajaxValue(html_entity_decode($chart['titel'],ENT_COMPAT,'UTF-8'));?>","<?ajaxEcho($currentValue);?>"]});
<?
					$this->visibleYaxis++;
				}
				if ($yAnz>0) {$chartNumber++;}
			}
		}
		sql_close($ss1);
	
		if ($chartNumber>0) {
			//Y-Achsen und Grids zeichnen
?>				
			yAxisMaxWidth=control21_drawYaxis(<?echo $this->objId;?>,[<?echo $this->chartMarginX;?>,<?echo $this->chartMarginY;?>,<?echo $this->chartWidth;?>,<?echo $this->chartHeight;?>],axis);
<?
			return true;
		} else {
			//es existieren keine Daten für diesen Zeitraum (über alle Diagramme)
			return false;
		}
	}
	
	private function drawXaxis($chartCount) {
		global $global_weekdays;
	
		if ($this->chartMeta['mode']==0) {
			//-------------------------------- keine Kummulation ------------------------------------------
	
			//NÄHERUNG: Pro Y-Achse wird eine Breite von 30px angenommen (die genaue Breite ist nur JS bekannt, nicht jedoch PHP)
			$maxTicksX=truncFloat(($this->chartWidth-($this->visibleYaxis*30))/($this->chartFontsize*2));

			//Abstand in s zwischen 2 Ticks, die einen (annähernd) perfekten Abstand haben
			$diffTick=truncFloat((strtotime($this->chartInt2)-strtotime($this->chartInt1))/$maxTicksX);

			if ($this->chartMeta['xunit']<0) {
				//X-Achse automatisch skalieren
				$d=$this->getDatevaluesFromSeconds($diffTick);
		
				//die "größte" Einheit finden
				$unitTick=-1;
				for ($t=5;$t>=0;$t--) {
					if ($d[$t]>0) {
						$unitTick=$t;
						break;
					}
				}

				if ($unitTick>=0) {
					do {
						$intervalTick=-1;
	
						if ($unitTick==0) { //Sekunden
							$niceInterval=array(1,5,10,15,30);
							$niceStart=array(0,30);
						}
						if ($unitTick==1) { //Minuten
							$niceInterval=array(1,5,10,15,30);
							$niceStart=array(0,30);
						}
						if ($unitTick==2) { //Stunden
							$niceInterval=array(1,2,4,6,12);
							$niceStart=array(0,12);
						}
						if ($unitTick==3) { //Tage (andere Intervalle sind blöd, weil ein Monat ja 28,29,30,31 Tage haben kann...)
							$niceInterval=array(1);
							$niceStart=array();
						}
						if ($unitTick==4) { //Monate
							$niceInterval=array(1,2,3,6);
							$niceStart=array(1,7);
						}
						if ($unitTick==5) { //Jahre
							$niceInterval=array(1,2,3,4,5,6,7,8,9,10,15,20,30,40,50,100,200,300,400,500,1000,2000,10000);
							$niceStart=array();
						}
		
						//nächst größeres niceInterval finden
						for ($t=0;$t<count($niceInterval);$t++) {
							if ($niceInterval[$t]>=intval($d[$unitTick])) {
								$intervalTick=$niceInterval[$t];
								break;
							}
						}
		
						//wenn nicht vorhanden: nächst größere Einheit nehmen...
						if ($intervalTick<0) {
							$unitTick++;
						}
					} while ($intervalTick<0 && $unitTick<6);
		
					//Zeichnen
					$this->drawXaxisInterval($unitTick,$intervalTick,$diffTick);
				}				

			} else {
				//X-Achse manuell skalieren
				//Zeichnen
				$this->drawXaxisInterval($this->chartMeta['xunit'],$this->chartMeta['xinterval'],$diffTick);
			}


		} else {
			//-------------------------------- Kummulation ------------------------------------------
	
			$kum=$this->getKummulationData();
	
			$xCount=abs($kum[1]-$kum[0])+1;
?>
			var points1=new Array();
			var points2=new Array();
			var xfak=(<?echo ($this->chartWidth-(2*$this->chartMarginX));?>-yAxisMaxWidth)/(<?echo $xCount;?>);
			var xfakc=xfak/2;
<?
			for ($x=0;$x<$xCount;$x++) {
				if ($this->chartMeta['mode']==1) {$legend=$x;}
				if ($this->chartMeta['mode']==2) {$legend=$x;}
				if ($this->chartMeta['mode']==3) {$legend=$x;}
				if ($this->chartMeta['mode']==4) {$legend=substr($global_weekdays[$x],0,2);}
				if ($this->chartMeta['mode']==5) {$legend=$x+1;}
				if ($this->chartMeta['mode']==6) {$legend=$x+1;}
				if ($this->chartMeta['mode']==7) {$legend=$x+1;}
				if ($this->chartMeta['mode']==8) {$legend=$x+intval(date('Y',strtotime($this->chartInt1)));}
				if ($this->chartMeta['mode']==9) {$legend='Gesamter Zeitraum';}
?>
				points1.push({x:((xfak*<?echo $x;?>)+xfakc),c:"<?ajaxEcho($legend);?>"});
<?
			}
?>
			control21_drawXaxis(<?echo $this->objId;?>,[<?echo $this->chartMarginX;?>,<?echo $this->chartMarginY;?>,<?echo $this->chartWidth;?>,<?echo $this->chartHeight;?>],yAxisMaxWidth,textHeight,points1,points2,"<?ajaxEcho($kum[2]);?>",true);
<?
		}
	}

	private function drawXaxisInterval($unitTick,$intervalTick,$diffTick) {
?>
		var points1=new Array();
		var points2=new Array();
		var xfak=(<?echo ($this->chartWidth-(2*$this->chartMarginX));?>-yAxisMaxWidth) / <?echo abs(strtotime($this->chartInt2)-strtotime($this->chartInt1));?>;
<?

		//Ticks
		//-----------------------------------
		$d0=$this->getNiceStart_Date($unitTick,$intervalTick);
		
		//Faktor bestimmen
		$tmp=$this->getNiceStart_Tick1($d0,$unitTick,$intervalTick,1);
		$tickFaktor=truncFloat($diffTick/(strtotime($tmp)-strtotime($d0)));
		if ($tickFaktor<1) {$tickFaktor=1;}

		while (strtotime($d0)<strtotime($this->chartInt2)) {
			if ($unitTick==0) {$legend=intVal(substr($d0,17,2));}
			if ($unitTick==1) {$legend=intVal(substr($d0,14,2));}
			if ($unitTick==2) {$legend=intVal(substr($d0,11,2));}
			if ($unitTick==3) {$legend=intVal(substr($d0,8,2));}
			if ($unitTick==4) {$legend=intVal(substr($d0,5,2));}
			if ($unitTick==5) {$legend=substr($d0,0,4);}
?>
			points1.push({x:(xfak*<?echo (strtotime($d0)-strtotime($this->chartInt1));?>),c:"<?ajaxEcho($legend);?>"});
<?
			$d0=$this->getNiceStart_Tick1($d0,$unitTick,$intervalTick,$tickFaktor);
		}	


		//Trennlinien
		//-----------------------------------
		$d0=$this->chartInt1;
		$lastTick=-$diffTick;

		//Startdatum nicen
		if ($unitTick==0) {$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,17).'00 +1 minute'));}			//um xx:xx:00 Uhr
		if ($unitTick==1) {$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,14).'00:00 +1 hour'));}			//um xx:00:00 Uhr
		if ($unitTick==2) {$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,10).' 00:00:00 +1 day'));}		//um 00:00:00 Uhr
		if ($unitTick==3) {$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,7).'-01 00:00:00 +1 month'));}	//am 1. eines Monats
		if ($unitTick==4) {$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,4).'-01-01 00:00:00 +1 year'));}	//am 1.1. eines Jahres
		if ($unitTick==5) {																					//am 1.1. alle 5 Jahre (Startjahr wird auf 5 aufgerundet)
			$tmp=sprintf("%04d",truncFloat(ceil((truncFloat(substr($d0,0,4))+1)/5)*5));
			$d0=date("Y-m-d H:i:s", strtotime($tmp.'-01-01 00:00:00'));
		}

		//Faktor bestimmen		
		$tmp=$this->getNiceStart_Tick2($d0,$unitTick,1);
		$tickFaktor=truncFloat($diffTick/(strtotime($tmp)-strtotime($d0)));
		if ($tickFaktor<1) {$tickFaktor=1;}

		while (strtotime($d0)<strtotime($this->chartInt2)) {
			if ($unitTick==0) {$legend2=date("d.m.Y",strtotime($d0)).' &bull; '.date("H:i:s",strtotime($d0));}
			if ($unitTick==1) {$legend2=date("d.m.Y",strtotime($d0)).' &bull; '.date("H:i:s",strtotime($d0));}
			if ($unitTick==2) {$legend2=date("d.m.Y",strtotime($d0)).' &bull; '.date("H:i:s",strtotime($d0));}
			if ($unitTick==3) {$legend2=date("d.m.Y",strtotime($d0));}
			if ($unitTick==4) {$legend2=date("m.Y",strtotime($d0));}
			if ($unitTick==5) {$legend2=date("Y",strtotime($d0));}
?>
			points2.push({x:(xfak*<?echo (strtotime($d0)-strtotime($this->chartInt1));?>),c:"<?ajaxEcho(html_entity_decode($legend2,ENT_COMPAT,'UTF-8'));?>"});
<?
			$d0=$this->getNiceStart_Tick2($d0,$unitTick,$tickFaktor);
		}


		//Zeichnen
		$unitName=array('Sekunde','Minute','Stunde','Tag','Monat','Jahr');
?>
		control21_drawXaxis(<?echo $this->objId;?>,[<?echo $this->chartMarginX;?>,<?echo $this->chartMarginY;?>,<?echo $this->chartWidth;?>,<?echo $this->chartHeight;?>],yAxisMaxWidth,textHeight,points1,points2,"<?ajaxEcho($unitName[$unitTick]);?>",false);
<?
	}

	private function getNiceStart_Date($unitTick,$intervalTick) {
		$d0=$this->chartInt1;
		if ($unitTick==0) {
			$tmp=sprintf("%02d",truncFloat(substr($d0,17,2)/$intervalTick)*$intervalTick);
			$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,17).$tmp));
			if (strtotime($d0)<strtotime($this->chartInt1)) {$d0=date("Y-m-d H:i:s",strtotime($d0.' +'.$intervalTick.' seconds'));}
		}
		if ($unitTick==1) {
			$tmp=sprintf("%02d",truncFloat(substr($d0,14,2)/$intervalTick)*$intervalTick);
			$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,14).$tmp.':00'));
			if (strtotime($d0)<strtotime($this->chartInt1)) {$d0=date("Y-m-d H:i:s",strtotime($d0.' +'.$intervalTick.' minutes'));}
		}
		if ($unitTick==2) {
			$tmp=sprintf("%02d",truncFloat(substr($d0,11,2)/$intervalTick)*$intervalTick);
			$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,11).$tmp.':00:00'));
			if (strtotime($d0)<strtotime($this->chartInt1)) {$d0=date("Y-m-d H:i:s",strtotime($d0.' +'.$intervalTick.' hours'));}
		}
		if ($unitTick==3) {
			$tmp=sprintf("%02d",truncFloat(substr($d0,8,2)/$intervalTick)*$intervalTick);
			$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,8).$tmp.' 00:00:00'));
			if (strtotime($d0)<strtotime($this->chartInt1)) {$d0=date("Y-m-d H:i:s",strtotime($d0.' +'.$intervalTick.' days'));}
		}
		if ($unitTick==4) {
			$tmp=sprintf("%02d",truncFloat(substr($d0,5,2)/$intervalTick)*$intervalTick);
			$d0=date("Y-m-d H:i:s", strtotime(substr($d0,0,5).$tmp.'-01 00:00:00'));
			if (strtotime($d0)<strtotime($this->chartInt1)) {$d0=date("Y-m-d H:i:s",strtotime($d0.' +'.$intervalTick.' months'));}
		}
		if ($unitTick==5) {
			$tmp=sprintf("%04d",truncFloat(substr($d0,0,4)/$intervalTick)*$intervalTick);
			$d0=date("Y-m-d H:i:s", strtotime($tmp.'-01-01 00:00:00'));
			if (strtotime($d0)<strtotime($this->chartInt1)) {$d0=date("Y-m-d H:i:s",strtotime($d0.' +'.$intervalTick.' years'));}
		}
		return $d0;
	}

	private function getNiceStart_Tick1($d0,$unitTick,$intervalTick,$tickFaktor) {
		if ($unitTick==0) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.($intervalTick*$tickFaktor).' seconds'));}
		if ($unitTick==1) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.($intervalTick*$tickFaktor).' minutes'));}
		if ($unitTick==2) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.($intervalTick*$tickFaktor).' hours'));}
		if ($unitTick==3) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.($intervalTick*$tickFaktor).' days'));}
		if ($unitTick==4) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.($intervalTick*$tickFaktor).' months'));}
		if ($unitTick==5) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.($intervalTick*$tickFaktor).' years'));}
		return $d0;
	}

	private function getNiceStart_Tick2($d0,$unitTick,$tickFaktor) {
		if ($unitTick==0) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.(1*$tickFaktor).' minute'));}
		if ($unitTick==1) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.(1*$tickFaktor).' hour'));}
		if ($unitTick==2) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.(1*$tickFaktor).' day'));}
		if ($unitTick==3) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.(1*$tickFaktor).' month'));}
		if ($unitTick==4) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.(1*$tickFaktor).' year'));}
		if ($unitTick==5) {$d0=date("Y-m-d H:i:s", strtotime($d0.' +'.(5*$tickFaktor).' years'));}
		return $d0;
	}
	
	private function drawTitel($chartCount) {
?>				
		control21_drawTitel(<?echo $this->objId;?>,[<?echo $this->chartMarginX;?>,<?echo $this->chartMarginY;?>,<?echo $this->chartWidth;?>,<?echo $this->chartHeight;?>],yAxisMaxWidth,"<?ajaxValue(html_entity_decode($this->chartMeta['titel'],ENT_COMPAT,'UTF-8'));?>","<?ajaxEcho(date("d.m.Y / H:i:s", strtotime($this->chartInt1)));?>","<?ajaxEcho(date("d.m.Y / H:i:s", strtotime($this->chartInt2)));?>");
<?
	}
	
	private function drawCharts($chartCount) {		
		//Charts zeichnen
		$ss1=sql_call("SELECT * FROM edomiLive.chartList WHERE (targetid=".$this->chartId.") ORDER BY id DESC");
		while ($chart=sql_result($ss1)) {
	
			//Clipping
			$tmp=$chart['s3'];
			if ($chart['charttyp2']>0 && $chart['ss3']>$chart['s3']) {$tmp=$chart['ss3'];} 
?>
			c.save();
			c.beginPath();
				c.rect(<?echo ($this->chartMarginX/2);?>,<?echo ($this->chartMarginY-$tmp);?>,<?echo intval($this->chartWidth-$this->chartMarginX);?>-yAxisMaxWidth,<?echo intval($this->chartHeight-(2*$this->chartMarginY)+(2*$tmp));?>);
			c.clip();
<?
	
			//Farbe holen
			$chart['s1']=sql_getValue('edomiLive.visuFGcol','color',"id='".$chart['s1']."'");
			$chart['ss1']=sql_getValue('edomiLive.visuFGcol','color',"id='".$chart['ss1']."'");
	
			//Min/Max/Anzahl der Werte
			$ss2=sql_call("SELECT COUNT(datetime) AS anz0,MIN(CAST(gavalue AS DECIMAL(20,4))) AS anz1,MAX(CAST(gavalue AS DECIMAL(20,4))) AS anz2 FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."')");
			if ($nn=sql_result($ss2)) {
				$yAnz=$nn['anz0'];
				$yMin=$nn['anz1'];
				$yMax=$nn['anz2'];
			}
			sql_close($ss2);

			//ggf. globale Y-Einstellungen verwenden
			if ($chart['yscale']==1 && !isEmpty($this->chartMeta['ymin']) && !isEmpty($this->chartMeta['ymax'])) {
				$chart['ymin']=$this->chartMeta['ymin'];
				$chart['ymax']=$this->chartMeta['ymax'];
				$chart['yticks']=$this->chartMeta['yticks'];
				$chart['ynice']=$this->chartMeta['ynice'];
			}
	
			//wenn ymin und/oder ymax gesetzt sind: die db-Werte nehmen (also ymin/ymax)
			if (!isEmpty($chart['ymin'])) {$yMin=$chart['ymin'];}
			if (!isEmpty($chart['ymax'])) {$yMax=$chart['ymax'];}
	
			if ($yAnz>0) { //gibt es überhaupt Daten für dieses Diagramm (in diesem Zeitraum)?
	
				if (isEmpty($chart['yticks']) || $chart['yticks']==0) {
					$chart['yticks']=floor(($this->chartHeight-(2*$this->chartMarginY))/($this->chartFontsize*2));
				}
	
				$tmp=$this->getInterval($yMin,$yMax,$chart['yticks'],$chart['ynice']);
	
				$yMin=$tmp[0];
				$yMax=$tmp[1];
				$range=$tmp[2];
				$tickCount=$tmp[3];
				$tickSpacing=$tmp[4];
?>
				var xfak=(<?echo ($this->chartWidth-(2*$this->chartMarginX));?>-yAxisMaxWidth) / <?echo abs(strtotime($this->chartInt2)-strtotime($this->chartInt1));?>;
				var xfakc=xfak/2;
<?
				$yfak=($this->chartHeight-(2*$this->chartMarginY))/$range;
	
				if ($this->chartMeta['mode']==0) {
	
					//-------------------------------- keine Kummulation ------------------------------------------
	
?>
					var points=new Array();
<?

					//X-Intervall ggf. automatisch vergrößern (Downsampling)
					if (isEmpty($chart['xinterval']) || $chart['xinterval']==0) {
						if (($yAnz/$this->chartWidth)>1) {	//Näherung, da exakte Chartbreite ja nicht bekannt ist (für PHP)
							$chart['xinterval']=round(abs(strtotime($this->chartInt2)-strtotime($this->chartInt1))/$this->chartWidth);
						} else {
							$chart['xinterval']=1;
						}
						if ($chart['xinterval']<1) {$chart['xinterval']=1;}
					}

					$y=false;

					$ss2=sql_call("SELECT UNIX_TIMESTAMP(datetime) AS anz1,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY FLOOR((UNIX_TIMESTAMP(datetime)-".strtotime($this->chartInt1).")/".$chart['xinterval'].") ORDER BY datetime ASC,ms ASC");
					while ($nn=sql_result($ss2)) {
						$y=($this->chartHeight-$this->chartMarginY)-($yfak*(floatval($nn['vavg'])-$yMin));
						$y1=($this->chartHeight-$this->chartMarginY)-($yfak*(floatval($nn['vmin'])-$yMin));
						$y2=($this->chartHeight-$this->chartMarginY)-($yfak*(floatval($nn['vmax'])-$yMin));
	
						//X auf das Intervall einrasten
						$x=truncFloat(($nn["anz1"]-strtotime($this->chartInt1))/$chart['xinterval'])*$chart['xinterval'];
	
						//offsetX: Mitte des X-Intervalls (relativ)							
						$offsetX=$chart['xinterval']/2;
						if (($nn["anz1"]-strtotime($this->chartInt1)+$offsetX)>(strtotime($this->chartInt2)-strtotime($this->chartInt1))) {$offsetX=0;}							
	
						if ($chart['yminmax']==1 && ($y!=$y1 || $y!=$y2)) {
?>
							points.push({x:(<?echo $this->chartMarginX;?>+(xfak*<?echo $x;?>)),y:<?echo $y;?>,y1:<?echo $y1;?>,y2:<?echo $y2;?>,w:(xfak*<?echo $offsetX;?>)});
<?
						} else {
?>
							points.push({x:(<?echo $this->chartMarginX;?>+(xfak*<?echo $x;?>)),y:<?echo $y;?>,y1:null,y2:null,w:(xfak*<?echo $offsetX;?>)});
<?
						}
					}
					sql_close($ss2);
	
					if ($y!==false) {
	
						//Startpunkt verlängern
						//-------------------------------------------
						if ($chart['extend1']==0) {			//ersten Punkt wiederholen (=eliminieren)
?>
							points.unshift({x:points[0].x,y:points[0].y,y1:null,y2:null,w:points[0].w});
<?
						} else if ($chart['extend1']==1) {	//ersten Punkt bis zum Rand verlängern
?>
							points.unshift({x:<?echo $this->chartMarginX;?>,y:points[0].y,y1:null,y2:null,w:0});
<?
						} else if ($chart['extend1']==2) {	//Vorgänger
							$ss2=sql_call("SELECT UNIX_TIMESTAMP(datetime) AS anz1,CAST(gavalue AS DECIMAL(20,4)) AS vavg FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime<'".$this->chartInt1."') ORDER BY datetime DESC,ms DESC LIMIT 0,1");
							if ($n=sql_result($ss2)) {
?>
								points.unshift({x:<?echo intVal($n["anz1"]-strtotime($this->chartInt1));?>,y:<?echo ($this->chartHeight-$this->chartMarginY)-($yfak*(floatval($n['vavg'])-$yMin));?>,y1:null,y2:null,w:0});
<?
							} else {
?>
								points.unshift({x:<?echo $this->chartMarginX;?>,y:points[0].y,y1:null,y2:null,w:0});
<?
							}
							sql_close($ss2);
						}
	
						//Endpunkt verlängern
						//-------------------------------------------
						if ($chart['extend2']==0) {			//letzen Punkt wiederholen (=eliminieren)
?>
							points.push({x:points[points.length-1].x,y:points[points.length-1].y,y1:null,y2:null,w:points[points.length-1].w});
<?
						} else if ($chart['extend2']==1) {	//letzen Punkt bis zum Rand verlängern
?>
							points.push({x:(<?echo ($this->chartWidth-(1*$this->chartMarginX));?>-yAxisMaxWidth),y:points[points.length-1].y,y1:null,y2:null,w:0});
<?
						} else if ($chart['extend2']==2) {	//Nachfolger
							$ss2=sql_call("SELECT UNIX_TIMESTAMP(datetime) AS anz1,CAST(gavalue AS DECIMAL(20,4)) AS vavg FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>'".$this->chartInt2."') ORDER BY datetime ASC,ms ASC LIMIT 0,1");
							if ($n=sql_result($ss2)) {
?>
								points.push({x:(<?echo $this->chartMarginX;?>+(xfak*<?echo intVal($n["anz1"]-strtotime($this->chartInt1));?>)),y:<?echo ($this->chartHeight-$this->chartMarginY)-($yfak*(floatval($n['vavg'])-$yMin));?>,y1:null,y2:null,w:0});
<?
							} else {
?>
								points.push({x:(<?echo ($this->chartWidth-(1*$this->chartMarginX));?>-yAxisMaxWidth),y:points[points.length-1].y,y1:null,y2:null,w:0});
<?
							}
							sql_close($ss2);
						}
	
?>
						control21_drawChart(<?echo $this->objId;?>,<?echo $chart['charttyp'];?>,false,true,<?echo intval($this->chartHeight-$this->chartMarginY);?>,<?echo $this->chartMarginY;?>,[pS("<?ajaxEcho($chart['s1']);?>","<?ajaxEcho($this->koValue);?>"),"<?echo ($chart['s2']/100);?>","<?echo $chart['s3'];?>","<?echo $chart['s4'];?>"],points);
<?			
						if ($chart['charttyp2']>0) {
?>
							control21_drawChart(<?echo $this->objId;?>,<?echo $chart['charttyp2'];?>,false,false,<?echo intval($this->chartHeight-$this->chartMarginY);?>,<?echo $this->chartMarginY;?>,[pS("<?ajaxEcho($chart['ss1']);?>","<?ajaxEcho($this->koValue);?>"),"<?echo ($chart['ss2']/100);?>","<?echo $chart['ss3'];?>","<?echo $chart['ss4'];?>"],points);
<?
						}
	
					}						
	
	
				} else {
	
					//-------------------------------- Kummulation ------------------------------------------
	
					$kum=$this->getKummulationData();
?>
					var points=new Array();
					var xfak=(<?echo ($this->chartWidth-(2*$this->chartMarginX));?>-yAxisMaxWidth)/(<?echo (abs($kum[1]-$kum[0])+1);?>);
					var xfakc=xfak/2;
<?
					$y=false;
					$c=0;
	
					if ($this->chartMeta['mode']==1) {$ss2=sql_call("SELECT SECOND(datetime) AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY SECOND(datetime) ORDER BY SECOND(datetime) ASC");} //Kummulation: Sekunden
					if ($this->chartMeta['mode']==2) {$ss2=sql_call("SELECT MINUTE(datetime) AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY MINUTE(datetime) ORDER BY MINUTE(datetime) ASC");} //Kummulation: Minuten
					if ($this->chartMeta['mode']==3) {$ss2=sql_call("SELECT HOUR(datetime) AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY HOUR(datetime) ORDER BY HOUR(datetime) ASC");} //Kummulation: Stunden
					if ($this->chartMeta['mode']==4) {$ss2=sql_call("SELECT WEEKDAY(datetime) AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY WEEKDAY(datetime) ORDER BY WEEKDAY(datetime) ASC");} //Kummulation: Wochentage
					if ($this->chartMeta['mode']==5) {$ss2=sql_call("SELECT (DAY(datetime)-1) AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY (DAY(datetime)-1) ORDER BY (DAY(datetime)-1) ASC");} //Kummulation: Tag
					if ($this->chartMeta['mode']==6) {$ss2=sql_call("SELECT WEEK(datetime,5) AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY WEEK(datetime,5) ORDER BY WEEK(datetime,5) ASC");} //Kummulation: Tag
					if ($this->chartMeta['mode']==7) {$ss2=sql_call("SELECT (MONTH(datetime)-1) AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY (MONTH(datetime)-1) ORDER BY (MONTH(datetime)-1) ASC");} //Kummulation: Monat
					if ($this->chartMeta['mode']==8) {$ss2=sql_call("SELECT (YEAR(datetime)-".$kum[0].") AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."') GROUP BY (YEAR(datetime)-".$kum[0].") ORDER BY (YEAR(datetime)-".$kum[0].") ASC");} //Kummulation: Jahr
					if ($this->chartMeta['mode']==9) {$ss2=sql_call("SELECT 0 AS xpos,AVG(CAST(gavalue AS DECIMAL(20,4))) AS vavg,MIN(CAST(gavalue AS DECIMAL(20,4))) AS vmin,MAX(CAST(gavalue AS DECIMAL(20,4))) AS vmax FROM edomiLive.archivKoData WHERE (targetid=".$chart['archivkoid']." AND datetime>='".$this->chartInt1."' AND datetime<='".$this->chartInt2."')");} //Kummulation: ALLES
					while ($nn=sql_result($ss2)) {
						$c++;
						$y=($this->chartHeight-$this->chartMarginY)-($yfak*(floatval($nn['vavg'])-$yMin));
						$y1=($this->chartHeight-$this->chartMarginY)-($yfak*(floatval($nn['vmin'])-$yMin));
						$y2=($this->chartHeight-$this->chartMarginY)-($yfak*(floatval($nn['vmax'])-$yMin));
						if ($chart['yminmax']==1 && ($y!=$y1 || $y!=$y2)) {
?>
							points.push({x:(<?echo $this->chartMarginX;?>+(xfak*<?echo $nn['xpos'];?>))+xfakc,y:<?echo $y;?>,y1:<?echo $y1;?>,y2:<?echo $y2;?>,w:0,w2:xfak});
<?
						} else {
?>
							points.push({x:(<?echo $this->chartMarginX;?>+(xfak*<?echo $nn['xpos'];?>))+xfakc,y:<?echo $y;?>,y1:null,y2:null,w:0,w2:xfak});
<?
						}
					}
					sql_close($ss2);
					
					if ($y!==false) {
						if ($c==1) {
?>
							points.unshift({x:<?echo $this->chartMarginX;?>,y:points[0].y,y1:null,y2:null,w:0});
							points.push({x:(<?echo ($this->chartWidth-(1*$this->chartMarginX));?>-yAxisMaxWidth),y:<?echo $y;?>,y1:null,y2:null,w:0});
<?
						} else {
?>
							points.unshift({x:points[0].x,y:points[0].y,y1:null,y2:null,w:0});
							points.push({x:points[points.length-1].x,y:points[points.length-1].y,y1:null,y2:null,w:0});
<?
						}
?>
						control21_drawChart(<?echo $this->objId;?>,<?echo $chart['charttyp'];?>,true,true,<?echo intval($this->chartHeight-$this->chartMarginY);?>,<?echo $this->chartMarginY;?>,[pS("<?ajaxEcho($chart['s1']);?>","<?ajaxEcho($this->koValue);?>"),"<?echo ($chart['s2']/100);?>","<?echo $chart['s3'];?>","<?echo $chart['s4'];?>"],points);
<?
						if ($chart['charttyp2']>0) {
?>
							control21_drawChart(<?echo $this->objId;?>,<?echo $chart['charttyp2'];?>,true,false,<?echo intval($this->chartHeight-$this->chartMarginY);?>,<?echo $this->chartMarginY;?>,[pS("<?ajaxEcho($chart['ss1']);?>","<?ajaxEcho($this->koValue);?>"),"<?echo ($chart['ss2']/100);?>","<?echo $chart['ss3'];?>","<?echo $chart['ss4'];?>"],points);
<?
						}
					}
	
				}
	
			}
?>
			c.restore();
<?
		}
		sql_close($ss1);
	}
	
	private function getDatevaluesFromSeconds($s) {
		//liefert ein Array zurück, dass die Sekunden $s in Sekunden/Minuten/Stunden/Tage/Monate/Jahre umrechnet
		$d1 = new DateTime('@0');
		$d2 = $d1->diff(new DateTime('@'.$s));
		$n[0]=$d2->s;
		$n[1]=$d2->i;
		$n[2]=$d2->h;
		$n[3]=$d2->d;
		$n[4]=$d2->m;
		$n[5]=$d2->y;
		return $n;
	}
	
	private function getDatevaluesFromDate($d) {
		//liefert ein Array zurück, dass die einzelnen Teile eines DATETIME-Strings enthält (Sekunden/Minuten/Stunden/Tage/Monate/Jahre)
		$d1=strtotime($d);
		$n[0]=date('s',$d1);
		$n[1]=date('i',$d1);
		$n[2]=date('H',$d1);
		$n[3]=date('d',$d1);
		$n[4]=date('m',$d1);
		$n[5]=date('Y',$d1);
		return $n;
	}
	
	private function getDateFromDatevalues($d) {
		//liefert einen DATETIME-String zurück, der aus den einzelnen Teilen eines Arrays besteht (Sekunden/Minuten/Stunden/Tage/Monate/Jahre)
		return date("Y-m-d H:i:s",strtotime($d[5].'-'.$d[4].'-'.$d[3].' '.$d[2].':'.$d[1].':'.$d[0]));
	}
	
	private function parseDate($n) {
		$n=strtoupper($n);
		$n=str_replace('{SECOND}',date('s'),$n);
		$n=str_replace('{MINUTE}',date('i'),$n);
		$n=str_replace('{HOUR}',date('H'),$n);
		$n=str_replace('{DAY}',date('d'),$n);
		$n=str_replace('{MONTH}',date('m'),$n);
		$n=str_replace('{YEAR}',date('Y'),$n);
		return $n;
	}
	
	private function getInterval($yMin,$yMax,$chartTicksY,$nice) {
		if ($yMin>$yMax) {	//min/max ggf. vertauschen
			$tmp=$yMin;
			$yMin=$yMax;
			$yMax=$tmp;
		}
		
		if ($yMin==$yMax) {	//Sonderfall: min==max => generisches Intervall
			if ($yMin>0) {
				$yMin=0;
			} else if ($yMin<0) {
				$yMax=0;
			} else {
				$yMax=1;
			}
		}

		if ($nice==1) {	//Algorithmus 1
			$yMinRaw=$yMin;
			$yMaxRaw=$yMax;

//### die Schleife ist bislang überflüssig - ymin/ymax werden ggf. um 1x tickspacing erweitert und das sollte (in allen Fällen?) genügen
//			do {
				$range=$this->getNiceInterval(($yMax-$yMin),false);
				$tickSpacing=$this->getNiceInterval(($range/$chartTicksY),true);
	
				$tickCount=truncFloat($range/$tickSpacing);
				$yMax=ceil($yMax/$tickSpacing)*$tickSpacing;
				$yMin=$yMax-($tickSpacing*$tickCount);
	
				if ($yMinRaw>=0 && $yMin<0) {	//Sonderfall: min_nice<0 (aber min>=0) => ins Positive verschieben 
					$yMin=0;
					$yMax=$range;
				}

				if ($yMin>$yMinRaw) {
					$yMin-=$tickSpacing;
					$tickCount++;
				}
	
				if ($yMax<$yMaxRaw) {
					$yMax+=$tickSpacing;
					$tickCount++;
				}

//			} while (($yMin>$yMinRaw || $yMax<$yMaxRaw));			

			$range=($yMax-$yMin);
			return array($yMin,$yMax,$range,$tickCount,$tickSpacing);

		} else {	//ohne nice
			$range=$yMax-$yMin;
			$tickSpacing=$range/$chartTicksY;
			$tickCount=truncFloat($range/$tickSpacing);
			return array($yMin,$yMax,$range,$tickCount,$tickSpacing);
		}
	}
	
	private function getNiceInterval($range,$round) {
		$exp=floor(log10($range));
		$frac=$range/pow(10,$exp);
		if ($round) {
			if ($frac<1.5) {
				$r=1;
			} else if ($frac<3) {
				$r=2;
			} else if ($frac<7) {
				$r=5;
			} else {
				$r=10;
			}
		} else {
			if ($frac<=1) {
				$r=1;
			} else if ($frac<=2) {
				$r=2;
			} else if ($frac<=5) {
				$r=5;
			} else {
				$r=10;
			}
		}
		return $r*pow(10,$exp);
	}
	
	private function getKummulationData() {
		if ($this->chartMeta['mode']==1) {$xFrom=0; $xTo=59;	$unitName='Sekunde';} //Sekunden
		if ($this->chartMeta['mode']==2) {$xFrom=0; $xTo=59;	$unitName='Minute';} //Minuten
		if ($this->chartMeta['mode']==3) {$xFrom=0; $xTo=23;	$unitName='Stunde';} //Stunden
		if ($this->chartMeta['mode']==4) {$xFrom=0; $xTo=6;		$unitName='';	} //Wochentage (selbsterklärend)
		if ($this->chartMeta['mode']==5) {$xFrom=1; $xTo=31;	$unitName='Tag';} //Tage
		if ($this->chartMeta['mode']==6) {$xFrom=0; $xTo=53;	$unitName='Woche';} //Wochen
		if ($this->chartMeta['mode']==7) {$xFrom=1; $xTo=12;	$unitName='Monat';} //Monate
		if ($this->chartMeta['mode']==8) {$xFrom=intval(date('Y',strtotime($this->chartInt1))); $xTo=intval(date('Y',strtotime($this->chartInt2))); $unitName='Jahr';} //Jahre
		if ($this->chartMeta['mode']==9) {$xFrom=0; $xTo=0; $unitName='';} //Gesamter Zeitraum (selbsterklärend)
	
		return array($xFrom,$xTo,$unitName);
	}

}

?>