/* 
 * EDOMI beta (Version 1.59) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 12 (Dimmer/RGB/HSV)
//----------------------------

function control12_constructControl(obj,item) {
	if (!(obj.dataset.var1&3)) { 
		//Dimmer
		var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		if (obj.dataset.var3&2) {
			n+="<table cellpadding='0' cellspacing='0' width='100%' height='100%' border='0'>";
				n+="<tr valign='top'>";
					n+="<td align='left' style='padding-left:5%; padding-top:5%; width:50%;'>&nbsp;</td>";
					n+="<td align='right' style='padding-right:5%; padding-top:5%; width:50%;'>&nbsp;</td>";
				n+="</tr>";
				n+="<tr valign='bottom'>";
					n+="<td id='e-"+item.id+"-off' align='left' style='padding-left:5%; padding-bottom:5%; width:50%;'>"+((obj.dataset.var3&1)?"aus":"&nbsp;")+"</td>";
					n+="<td id='e-"+item.id+"-on' align='right' style='padding-right:5%; padding-bottom:5%; width:50%;'>"+((obj.dataset.var3&1)?"ein":"&nbsp;")+"</td>";
				n+="</tr>";
			n+="</table>";
		}
			n+=getContent();
		n+="</div>";
		obj.innerHTML=n;

		document.getElementById("e-"+item.id+"-wheel0").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,0);},false);
		if (obj.dataset.var3&2) {
			document.getElementById("e-"+item.id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,0);},false);
			document.getElementById("e-"+item.id+"-on").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,1);},false);
		}
	} else if (obj.dataset.var1&1) {
		//RGB-Dimmer
		var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
			n+="<table cellpadding='0' cellspacing='0' width='100%' height='100%' border='0'>";
				n+="<tr valign='top'>";
					n+="<td id='e-"+item.id+"-wheel1' align='left' style='padding-left:5%; padding-top:5%; width:50%;'>"+((obj.dataset.var3&1)?"R":"&nbsp;")+"</td>";
					n+="<td id='e-"+item.id+"-wheel2' align='right' style='padding-right:5%; padding-top:5%; width:50%;'>"+((obj.dataset.var3&1)?"G":"&nbsp;")+"</td>";
				n+="</tr>";
				n+="<tr valign='bottom'>";
					n+="<td id='e-"+item.id+"-off' align='left' style='padding-left:5%; padding-bottom:5%; width:50%;'>"+((obj.dataset.var3==3)?"aus":"&nbsp;")+"</td>";
					n+="<td id='e-"+item.id+"-wheel3' align='right' style='padding-right:5%; padding-bottom:5%; width:50%;'>"+((obj.dataset.var3&1)?"B":"&nbsp;")+"</td>";
				n+="</tr>";
			n+="</table>";
			n+=getContent();
		n+="</div>";
		obj.innerHTML=n;

		document.getElementById("e-"+item.id+"-wheel0").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,0);},false);
		document.getElementById("e-"+item.id+"-wheel1").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,1);},false);
		document.getElementById("e-"+item.id+"-wheel2").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,2);},false);
		document.getElementById("e-"+item.id+"-wheel3").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,3);},false);
		if (obj.dataset.var3&2) {
			document.getElementById("e-"+item.id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,0);},false);
		}
	} else if (obj.dataset.var1&2) {
		//HSV-Dimmer
		var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
			n+="<table cellpadding='0' cellspacing='0' width='100%' height='100%' border='0'>";
				n+="<tr valign='top'>";
					n+="<td id='e-"+item.id+"-wheel1' align='left' style='padding-left:5%; padding-top:5%; width:50%;'>"+((obj.dataset.var3&1)?"H":"&nbsp;")+"</td>";
					n+="<td id='e-"+item.id+"-wheel2' align='right' style='padding-right:5%; padding-top:5%; width:50%;'>"+((obj.dataset.var3&1)?"S":"&nbsp;")+"</td>";
				n+="</tr>";
		if (obj.dataset.var3&2) {
				n+="<tr valign='bottom'>";
					n+="<td id='e-"+item.id+"-off' align='left' style='padding-left:5%; padding-bottom:5%; width:50%;'>"+((obj.dataset.var3&1)?"aus":"&nbsp;")+"</td>";
					n+="<td id='e-"+item.id+"-on' align='right' style='padding-right:5%; padding-bottom:5%; width:50%;'>"+((obj.dataset.var3&1)?"ein":"&nbsp;")+"</td>";
				n+="</tr>";
		}
			n+="</table>";
			n+=getContent();
		n+="</div>";
		obj.innerHTML=n;

		document.getElementById("e-"+item.id+"-wheel0").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,0);},false);
		document.getElementById("e-"+item.id+"-wheel1").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,1);},false);
		document.getElementById("e-"+item.id+"-wheel2").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Start(item.id,2);},false);
		if (obj.dataset.var3&2) {
			document.getElementById("e-"+item.id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,0);},false);
			document.getElementById("e-"+item.id+"-on").addEventListener(downEvent,function(){if (!checkClick()){return;} control12_Switch(item.id,1);},false);
		}
	}
	
	function getContent() {
		var n="";
		if (obj.dataset.var2&1) {
			n+="<div id='e-"+item.id+"-deco1' style='position:absolute; box-sizing:border-box; border:1px solid; border-radius:100%; background:transparent; pointer-events:none;'></div>";
			n+="<div id='e-"+item.id+"-deco2' style='position:absolute; box-sizing:border-box; pointer-events:none;'>";
				n+="<div style='display:block; margin-left:auto; margin-right:auto; width:0px; height:15%; border:1px solid;'></div>";
			n+="</div>";
		}

		n+="<div id='e-"+item.id+"-wheel0' style='position:absolute; left:0; top:0; box-sizing:border-box; border:2px solid transparent; border-radius:100%;'></div>";

		n+="<div id='e-"+item.id+"-cursor1' style='display:none; position:absolute; box-sizing:border-box; border-radius:100%; border: 2px solid "+((obj.dataset.var2&2)?visu_indiColor:"transparent")+";'>";
			if (obj.dataset.var2&2) {n+="<div style='display:block; margin-left:auto; margin-right:auto; width:2px; height:15%; background:"+visu_indiColor+";'></div>";}
		n+="</div>";

		n+="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
			n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
		n+="</table>";

		if (obj.dataset.var2&4) {n+="<div id='e-"+item.id+"-editvalue' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; color:"+visu_indiColorText+"; pointer-events:none;'></div>";}
		return n;
	}
}

function control12_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	document.getElementById("e-"+obj.dataset.id+"-text").innerHTML=pS(obj.dataset.d_text,kovalue);
	control12_Init(obj.dataset.id);
}

function control12_Init(elementId) {
	var d=document.getElementById("e-"+elementId);

	var kovalue=getKoValue(d);

	element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-wheel0"),10);
	if (d.dataset.var2&1) {
		element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-deco1"),10);
		element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-deco2"),10);
	}

	//aktuelle Farbe/Helligkeit anzeigen
	if (!(d.dataset.var1&3)) { //Dimmer
		var hsv=RGBtoHSV(kovalue,kovalue,kovalue);
		ringStatus(hsv);
	}
	if (d.dataset.var1&1) { //RGB-Dimmer
		var hsv=RGBHEXtoHSV(kovalue);
		ringStatus(hsv);
	}
	if (d.dataset.var1&2) { //HSV-Dimmer
		var hsv=HSVHEXtoHSV(kovalue);
		ringStatus(hsv);
	}

	function ringStatus(hsv) {
		var obj=document.getElementById("e-"+elementId+"-wheel0");
		if (hsv!==false && hsv[2]>0) {
			if (d.dataset.var5&1) {
				var tmp=parseInt((obj.offsetWidth/100*10)/2);
				var rgba=HSVtoRGBA(hsv[0],hsv[1],hsv[2]);
				obj.style.boxShadow="0 0 "+tmp+"px "+tmp+"px rgba("+rgba[0]+","+rgba[1]+","+rgba[2]+","+rgba[3]+")";
			}
			if (d.dataset.var5&2) {
				var tmp=HSVtoRGB(hsv[0],hsv[1],255);
				obj.style.borderColor="rgb("+parseInt(tmp[0])+","+parseInt(tmp[1])+","+parseInt(tmp[2])+")";
				if (obj.dataset.var2&1) {document.getElementById("e-"+elementId+"-wheel0").style.display="none";}
			}
		} else {
			if (d.dataset.var5&1) {
				obj.style.boxShadow="none";
			}
			if (d.dataset.var5&2) {
				obj.style.borderColor="transparent";
				if (obj.dataset.var2&1) {document.getElementById("e-"+elementId+"-wheel0").style.display="block";}
			}
		}

		if (d.dataset.var2&1) {
			//Knopf
			var tmp=element_getDefaultPosition(parseInt(hsv[2]),0,255,0,360);
			if (tmp!==false) {document.getElementById("e-"+elementId+"-deco2").style.webkitTransform="rotate("+(tmp-180)+"deg)";}
		}
	}
}

function control12_Start(elementId,wheelId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);

	d.dataset.wheelid=wheelId;

	var kovalue=getKoValue(d);
	element_drag.id=elementId;
	resetKoValue_Interval(kovalue);

	if (d.dataset.var2&1 && d.dataset.var2&2 && d.dataset.var1&4) {
		document.getElementById("e-"+elementId+"-deco1").style.display="none";
		document.getElementById("e-"+elementId+"-deco2").style.display="none";
	}
	if (d.dataset.var2&2) {
		document.getElementById("e-"+elementId+"-cursor1").style.display="block";
		element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-cursor1"),10);
	}
	if (d.dataset.var2&4) {
		document.getElementById("e-"+elementId+"-text").style.display="none";
		document.getElementById("e-"+elementId+"-editvalue").style.display="block";
	}
	
	if (wheelId>0) {document.getElementById("e-"+elementId+"-wheel"+wheelId).style.background=visu_indiColor;}

	
	//Startwert
	var value=0;
	if (!(d.dataset.var1&3)) { //Dimmer
		if (parseInt(kovalue)>=0 && parseInt(kovalue)<=255) {
			value=parseInt(kovalue);
		} else {
			if (d.dataset.live==1) {d.dataset.livevalue="0";} else {d.dataset.value="0";}
		}
	}
	if (d.dataset.var1&1) { //RGB-Dimmer
		var rgb=RGBHEXtoRGB(kovalue);
		if (rgb!==false) {
			if (wheelId==0) { //Helligkeit (V)
				var hsv=RGBHEXtoHSV(kovalue);
				if (hsv!==false) {value=hsv[2];}
			}
			if (wheelId==1) {value=rgb[0];} //R
			if (wheelId==2) {value=rgb[1];} //G
			if (wheelId==3) {value=rgb[2];} //B
		} else {
			if (d.dataset.live==1) {d.dataset.livevalue="000000";} else {d.dataset.value="000000";}
		}
	}
	if (d.dataset.var1&2) { //HSV-Dimmer
		var hsv=HSVHEXtoHSV(kovalue);
		if (hsv!==false) {
			if (wheelId==0) {value=hsv[2];} //V
			if (wheelId==1) {value=hsv[0];} //H
			if (wheelId==2) {value=hsv[1];} //S
		} else {
			if (d.dataset.live==1) {d.dataset.livevalue="000000";} else {d.dataset.value="000000";}
		}
	}

	//KO parsen und Startposition merken
	getMouseValue(d,document.getElementById("e-"+elementId+"-container"),true,value,1,1,null,0,255,null,null,0,360,0,1,5);						

	control12_Move();

	window.addEventListener(moveEvent,control12_Move,false);
	window.addEventListener(upEvent,control12_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}
}

function control12_Move() {
	if (!event) var event=window.event;
	if (element_drag.id>0) {
		var d=document.getElementById("e-"+element_drag.id);
		if (d) {
			var kovalue=getKoValue(d);
			var canvas=document.getElementById("e-"+element_drag.id+"-container");
			var pos=getMouseValue(d,canvas,false,null,1,1,((d.dataset.var1&4)?1:2),0,255,null,null,0,360,0,1,5);
			var value="";
			
			if (!(d.dataset.var1&3)) { //Dimmer
				value=pos.valuex;
				document.getElementById("e-"+element_drag.id+"-cursor1").style.background="#"+RGBtoRGBHEX(value,value,value);
				if (d.dataset.var2&4) {
					document.getElementById("e-"+element_drag.id+"-editvalue").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(pos.valuex/2.55).toFixed(1)+" %</span></button>";
				}
			}

			if (d.dataset.var1&1) { //RGB-Dimmer
				var rgb=RGBHEXtoRGB(kovalue);
				if (d.dataset.wheelid==1) {value=RGBtoRGBHEX(pos.valuex,rgb[1],rgb[2]);}
				if (d.dataset.wheelid==2) {value=RGBtoRGBHEX(rgb[0],pos.valuex,rgb[2]);}
				if (d.dataset.wheelid==3) {value=RGBtoRGBHEX(rgb[0],rgb[1],pos.valuex);}
				if (d.dataset.wheelid==0) { //Sonderfall: Helligkeit (V)
					var hsv=RGBHEXtoHSV(kovalue);
					if (hsv!==false) {value=HSVtoRGBHEX(hsv[0],hsv[1],pos.valuex);}
				}

				document.getElementById("e-"+element_drag.id+"-cursor1").style.background="#"+value;
				if (d.dataset.var2&4) {
					if (d.dataset.wheelid>=0) {document.getElementById("e-"+element_drag.id+"-editvalue").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(pos.valuex/2.55).toFixed(1)+" %</span></button>";}
				}
			}

			if (d.dataset.var1&2) { //HSV-Dimmer
				var hsv=HSVHEXtoHSV(kovalue);
				if (d.dataset.wheelid==0) {value=HSVtoHSVHEX(hsv[0],hsv[1],pos.valuex);}
				if (d.dataset.wheelid==1) {value=HSVtoHSVHEX(pos.valuex,hsv[1],hsv[2]);}
				if (d.dataset.wheelid==2) {value=HSVtoHSVHEX(hsv[0],pos.valuex,hsv[2]);}

				document.getElementById("e-"+element_drag.id+"-cursor1").style.background="#"+HSVHEXtoRGBHEX(value);
				if (d.dataset.var2&4) {
					if (d.dataset.wheelid==0) {document.getElementById("e-"+element_drag.id+"-editvalue").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(pos.valuex/2.55).toFixed(1)+" %</span></button>";}
					if (d.dataset.wheelid==1) {document.getElementById("e-"+element_drag.id+"-editvalue").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(pos.valuex*(360/255)).toFixed(0)+" &deg;</span></button>";}
					if (d.dataset.wheelid==2) {document.getElementById("e-"+element_drag.id+"-editvalue").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+(pos.valuex/2.55).toFixed(1)+" %</span></button>";}
				}
			}

			if (d.dataset.var2&2) {document.getElementById("e-"+element_drag.id+"-cursor1").style.webkitTransform="rotate("+(pos.cursorx-180)+"deg)";}

			//KO setzen und Wert merken
			if (value!="") {
				element_drag.koeditvalue=value;
				setKoValue_Interval(element_drag.id,true,d.dataset.var4);			
			}
		}
	}
}

function control12_Send() {
	var d=document.getElementById("e-"+element_drag.id);
	if (d) {
		setKoValue_Interval(element_drag.id,false);

		document.getElementById("e-"+element_drag.id+"-text").style.display="inline";
		if (d.dataset.var2&1) {
			document.getElementById("e-"+element_drag.id+"-deco1").style.display="block";
			document.getElementById("e-"+element_drag.id+"-deco2").style.display="block";
		}
		if (d.dataset.var2&4) {document.getElementById("e-"+element_drag.id+"-editvalue").style.display="none";}
		
		if (document.getElementById("e-"+element_drag.id+"-wheel1")) {document.getElementById("e-"+element_drag.id+"-wheel1").style.background="inherit";}
		if (document.getElementById("e-"+element_drag.id+"-wheel2")) {document.getElementById("e-"+element_drag.id+"-wheel2").style.background="inherit";}
		if (document.getElementById("e-"+element_drag.id+"-wheel3")) {document.getElementById("e-"+element_drag.id+"-wheel3").style.background="inherit";}
		document.getElementById("e-"+element_drag.id+"-cursor1").style.display="none";

		element_drag.id=0;
		window.removeEventListener(moveEvent,control12_Move,false);
		window.removeEventListener(upEvent,control12_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}
	}
}

function control12_Switch(elementId,value) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var kovalue=getKoValue(d);
		var newValue="";
		if (value==0) {
			showShortClickItem(document.getElementById("e-"+elementId+"-off"));	
			showShortClickItem(document.getElementById("e-"+elementId+"-wheel0"));	
			if (!(d.dataset.var1&3)) {newValue="0";}
			if (d.dataset.var1&1) {newValue="000000";}
			if (d.dataset.var1&2) {
				var hsv=HSVHEXtoHSV(kovalue);
				if (hsv!==false) {newValue=HSVtoHSVHEX(hsv[0],hsv[1],0);} else {newValue="000000";}
			}
		} else if (value==1) {
			showShortClickItem(document.getElementById("e-"+elementId+"-on"));
			showShortClickItem(document.getElementById("e-"+elementId+"-wheel0"));	
			if (!(d.dataset.var1&3)) {newValue="255";}
			if (d.dataset.var1&1) {newValue="ffffff";} //es gibt keinen Button hierfür...
			if (d.dataset.var1&2) {
				var hsv=HSVHEXtoHSV(kovalue);
				if (hsv!==false) {newValue=HSVtoHSVHEX(hsv[0],hsv[1],255);} else {newValue="ffffff";}
			}
		}
		
		if (newValue!="") {
			//Wert (bei Änderung) sofort setzen, Timer löschen, unblock=0 setzen
			resetKoValue_Interval(kovalue);
			element_drag.koeditvalue=newValue;
			setKoValue_Interval(elementId,false);
		}
	}
}
