/* 
 * EDOMI beta (Version 1.59) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 33 (Touchpad)
//----------------------------

function control33_constructControl(obj,item) {
	var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
		n+="<div id='e-"+item.id+"-canvas' style='position:absolute; left:0; top:0; width:100%; height:100%; background:transparent; box-sizing:border-box;'></div>";
		if (obj.dataset.var1&1) {
			n+="<div id='e-"+item.id+"-cursor1' style='display:none; position:absolute; z-index:99999; left:0; top:0; width:2px; height:100%; background:"+visu_indiColor+"; pointer-events:none; box-sizing:border-box;'></div>";
			n+="<div id='e-"+item.id+"-cursor2' style='display:none; position:absolute; z-index:99999; left:0; top:0; width:100%; height:2px; background:"+visu_indiColor+"; pointer-events:none; box-sizing:border-box;'></div>";
		} else if (obj.dataset.var1&2) {
			n+="<div id='e-"+item.id+"-cursor1' style='display:none; position:absolute; z-index:99999; left:0; top:0; width:0; height:0; border-radius:100%; border: 2px solid "+visu_indiColor+"; pointer-events:none; box-sizing:border-box;'>";
			if (obj.dataset.var3!=2) {n+="<div style='display:block; margin-left:auto; margin-right:auto; width:2px; height:15%; background:"+visu_indiColor+";'></div>";}
			n+="</div>";
		}
		n+="</div>";
		n+="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
			n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
		n+="</table>";
		if (obj.dataset.var2&2) {n+="<div id='e-"+item.id+"-editvalue' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; text-align:center; color:"+visu_indiColorText+"; pointer-events:none;'></div>";}
	n+="</div>";
	obj.innerHTML=n;
	
	obj.addEventListener(downEvent,function(){if (!checkClick()){return;} control33_Start(item.id);},false);
}

function control33_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	document.getElementById("e-"+obj.dataset.id+"-text").innerHTML=pS(obj.dataset.d_text,kovalue);
}

function control33_Start(elementId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);

	var kovalue=getKoValue(d);
	element_drag.id=elementId;
	resetKoValue_Interval(((d.dataset.var1&4)?"":kovalue));

	if (d.dataset.var2&1) {
		if (d.dataset.var1&2 || d.dataset.var3==0 || d.dataset.var3==1) {document.getElementById("e-"+elementId+"-cursor1").style.display="block";}
		if (d.dataset.var1&1 && (d.dataset.var3==0 || d.dataset.var3==2)) {document.getElementById("e-"+elementId+"-cursor2").style.display="block";}
	}
	if (d.dataset.var2&2) {
		document.getElementById("e-"+elementId+"-text").style.display="none";
		document.getElementById("e-"+elementId+"-editvalue").style.display="block";
	}
	
	//KO parsen und Startposition merken
	var canvas=document.getElementById("e-"+elementId+"-canvas");
	getMouseValue(d,canvas,true,kovalue,d.dataset.var3,((d.dataset.var1&1)?0:1),null,d.dataset.var5,d.dataset.var6,d.dataset.var7,d.dataset.var8,null,null,d.dataset.var10,d.dataset.var9);						
	
	control33_Move();

	window.addEventListener(moveEvent,control33_Move,false);
	window.addEventListener(upEvent,control33_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}
}

function control33_Move() {
	if (!event) var event=window.event;
	if (element_drag.id>0) {
		var d=document.getElementById("e-"+element_drag.id);
		if (d) {
		
			var canvas=document.getElementById("e-"+element_drag.id+"-canvas");
			var pos=getMouseValue(d,canvas,false,null,d.dataset.var3,((d.dataset.var1&1)?0:1),((d.dataset.var1&4)?0:1),d.dataset.var5,d.dataset.var6,d.dataset.var7,d.dataset.var8,null,null,d.dataset.var10,d.dataset.var9);						
			var valueX=pos.valuex;
			var valueY=pos.valuey;

			//KO-Format und Cursor anzeigen
			if (d.dataset.var3==0) {
				var value=valueX+","+valueY;
				if (d.dataset.var1&2) {
					setCursor(pos.objw/2,pos.objh/2,parseInt(pos.cursory)*2,parseInt(pos.cursory)*2,pos.cursorx-180);
				} else {
					setCursor(pos.cursorx,pos.cursory);
				}
			} else if (d.dataset.var3==1) {
				var value=valueX;
				if (d.dataset.var1&2) {
					if (pos.objw>=pos.objh) {var tmp=pos.objh;} else {var tmp=pos.objw;}
					setCursor(pos.objw/2,pos.objh/2,tmp,tmp,pos.cursorx-180);
				} else {
					setCursor(pos.cursorx,pos.objh/2);
				}
			} else if (d.dataset.var3==2) {
				var value=valueY;
				if (d.dataset.var1&2) {
					setCursor(pos.objw/2,pos.objh/2,parseInt(pos.cursory)*2,parseInt(pos.cursory)*2,0);
				} else {
					setCursor(pos.objw/2,pos.cursory);
				} 
			}

			if (d.dataset.var2&2) {document.getElementById("e-"+element_drag.id+"-editvalue").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+pS(d.dataset.d_caption,value.replace(","," &nbsp; "))+"</span></button>";}
			
			//KO setzen und Wert merken
			element_drag.koeditvalue=value;
			setKoValue_Interval(element_drag.id,true,d.dataset.var4);			
		}
	}
	
	function setCursor(x,y,w,h,a) {
		if (d.dataset.var2&1) {
			if (d.dataset.var1&1) {
				if (d.dataset.var3==0 || d.dataset.var3==1) {document.getElementById("e-"+element_drag.id+"-cursor1").style.left=(x-1)+"px";}
				if (d.dataset.var3==0 || d.dataset.var3==2) {document.getElementById("e-"+element_drag.id+"-cursor2").style.top=(y-1)+"px";}
			} else if (d.dataset.var1&2) {
				var cursor=document.getElementById("e-"+element_drag.id+"-cursor1");
				if (w<4) {w=4;}	//<4 Pixel führt zu Renderproblemen wegen box-sizing und border=2px
				if (h<4) {h=4;}
				cursor.style.width=w+"px";
				cursor.style.height=h+"px";
				cursor.style.left=(x-w/2)+"px";
				cursor.style.top=(y-h/2)+"px";
				cursor.style.webkitTransform="rotate("+a+"deg)";
			}
		}
	}
}

function control33_Send() {
	var d=document.getElementById("e-"+element_drag.id);
	if (d) {

		//Rückstellung
		if (d.dataset.var1&8) {
			element_drag.koeditvalue=getKoValue(d);
		}

		setKoValue_Interval(element_drag.id,false);

		document.getElementById("e-"+element_drag.id+"-text").style.display="block";
		document.getElementById("e-"+element_drag.id+"-cursor1").style.display="none";
		if (d.dataset.var1&1) {document.getElementById("e-"+element_drag.id+"-cursor2").style.display="none";}
		if (d.dataset.var2&2) {document.getElementById("e-"+element_drag.id+"-editvalue").style.display="none";}

		element_drag.id=0;
		window.removeEventListener(moveEvent,control33_Move,false);
		window.removeEventListener(upEvent,control33_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}

	}
}
